CUI_CONFIG_SHOWN = false;

CUI_START_DELAY = 2;

-- Controls des Config UI
local controls = {};

-- saved variables
CleanUICommonData = {};

-- saved variables per character
CleanUIData = {};
CleanUIWayPoints = {};
CleanUITradeSkillQueue = {};
CleanUIContainerLock = {};

-- initial values
CleanUIData.VERSION = nil;

CleanUIData.EQUIPPED_SETNAME = nil;

CleanUIData.SCREENSHOT = true;

CleanUIData.STATUSBAR_STYLE = 1;
CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\default";
CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\defaultVertical";

CleanUIData.CHANGE_ACTIONBARS = true;
CleanUIData.ACTIONBARS_SHOWMACRONAMES = false;
CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = 1;
CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = 1;
CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = 1;
CleanUIData.MASQUE_ACTIONBUTTONS = true;
CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = false;

CleanUIData.ACTIONBARS_DEBUFFS = true;
CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
CleanUIData.MASQUE_BUFFS = true;
CleanUIData.BIGGER_DEBUFFS = true;

CleanUIData.CHANGE_BAGS = true;
CleanUIData.BAGS_COLORIZE_ITEMS = true;
CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = true;
CleanUIData.BAGS_AUTOREPAIR = true;
CleanUIData.BAGS_AUTOSELLGRAY = true;
CleanUIData.BAGPACK_MINIMAP_POS = 45;

CleanUIData.CHANGE_CASTINGBARS = true;
CleanUIData.CASTINGBARS_SHOWPETBAR = true;
CleanUIData.CASTINGBARS_ALPHA = 1;
CleanUIData.CASTINGBARS_WIDTH = 300;
CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
CleanUIData.CASTINGBARS_IMAGESIZE = 24;
CleanUIData.CASTINGBARS_PETHEIGHT = 16;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = true;
CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
CleanUIData.CASTINGBARS_LATENCY = true;

CleanUIData.CHANGE_MINIMAP = true;
CleanUIData.MINIMAP_ALPHA = 1;
CleanUIData.WATCHFRAME_ALPHA = 0.75;
CleanUIData.MINIMAP_SHOWBUTTONBAR = true;
CleanUIData.MINIMAP_RIGHTBUTTONS = {};
CleanUIData.MAP_SHOWWAYPOINTS = true;
CleanUIData.TLOC_R = 1;
CleanUIData.TLOC_G = 1;
CleanUIData.TLOC_B = 1;

CleanUIData.CHANGE_UNITFRAMES = true;
CleanUIData.CHANGE_BOSSFRAMES = true;
CleanUIData.PORTRAIT_STYLE = 0;
CleanUIData.UNITFRAME_CUSTOM_POSITIONS = {};

CleanUIData.SHOW_XPFRAME = false;
CleanUIData.SHOW_ORIG_XPBAR = true;
CleanUIData.XPFRAME_WIDTH = 210;
CleanUIData.XPBAR_HEIGHT = 13;
CleanUIData.XPFRAME_X_XMAX = true;
CleanUIData.XPFRAME_PERCENT = true;
CleanUIData.XPFRAME_MAXLEVEL = false;
CleanUIData.XPFRAME_UNKNOWN = false;

CleanUIData.CHANGE_CHAT = true;
CleanUIData.DISABLE_ALTARROWKEYMODE = true;
CleanUIData.SHOW_CHAT_ACTIONBAR = true;
CleanUIData.SHOW_CHAT_EMOTICONS = true;
CleanUIData.CHAT_FONT_SIZE = 14;

CleanUIData.CHANGE_RAID = true;

CleanUIData.TOOLTIPS_HIDEINCOMBAT = false;
CleanUIData.TOOLTIPS_BACKDROP = true;
CleanUIData.TOOLTIPS_POSITION = 1;

CleanUIData.CHANGE_NAMEPLATES = true;
CleanUIData.NAMEPLATES_PERCENT = true;
CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = true;
CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = true;
CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS = true;
CleanUIData.NAMEPLATES_COMBATONLY = false;

CleanUIData.SHOW_DATABROKER = true;
CleanUIData.DATABROKER_COUNTROWS = 2;

CleanUIData.DataBroker_Disabled = {};

local STATUSBAR_STYLE = {
    "default",
    "Aluminium",
    "Bantobar",
    "Charcoal",
    "Flat",
    "Frost",
    "Glaze",
    "Healbot",
    "LiteStep",
    "Minimalist",
    "Otravi",
    "Perl",
    "Rocks",
    "Runes",
    "Smooth",
    "Smudge",
    "Striped",
    "SWS",
    "Xeon",
    "Xus",
}

local PORTRAIT_TYPE = {
    PORTRAIT_TYPE_3D,
    PORTRAIT_TYPE_CLASSITEM,
}

local TOOLTIPS_POSITION = {
    CONFIG_TOOLTIP_POSITION_STANDARD,
    CONFIG_TOOLTIP_POSITION_MOUSEPOSITION,
    CONFIG_TOOLTIP_POSITION_TOP,
    CONFIG_TOOLTIP_POSITION_BOTTOMRIGHT,
}

local FACTIONS = {
    FACTION_ALLIANCE,
    FACTION_HORDE,
    FACTION_OTHER,
    ALL,
    NONE,
}

function CleanUIConfig_OnLoad(self)
    CleanUIConfig_CreateUI(self);
    CleanUIConfig_InitDataBroker();

    self:RegisterEvent("ADDON_LOADED");
    self:RegisterEvent("CVAR_UPDATE");

    hooksecurefunc(InterfaceOptionsFrame, "Show", CleanUIConfig_InterfaceOptionsFrame_Show);
    hooksecurefunc(InterfaceOptionsFrame, "Hide", CleanUIConfig_InterfaceOptionsFrame_Hide);

    cui_config_loaded = true;
end

function CleanUIConfig_CreateUI(self)

    -- Hauptfenster
    self.name="CleanUI";
    self.addonname = "CleanUI";
    InterfaceOptions_AddCategory(self);

    local author = GetAddOnMetadata("CleanUI", "Author");
    local version = GetAddOnMetadata("CleanUI", "Version");

    -- ConfigFrame
    CleanUIConfig_CreateHeader(self, "CleanUI v"..version , "("..author..")");

    CleanUIConfig_AddCheckButton(self, "CUIConfig_ToggleScreenshot",
        CONFIG_TOGGLESCREENSHOT, CleanUIConfig_ToggleScreenshot);

    CleanUIConfig_AddSlider(self, "CUIConfig_SelectWatchFrameAlpha",
        CONFIG_TOGGLEWATCHFRAMEALPHA, 0, 1, 0.01, CleanUIConfig_SelectWatchFrameAlpha);

    CleanUIConfig_AddDropDown(self, "CUIConfig_StatusBarStyleDropDown",
        CONFIG_STATUSBAR_STYLE, CUIConfig_StatusBarStyleDropDown_Initialize);

    CleanUIConfig_AddLabel(self, "CUIConfig_Load and Save", CONFIG_LOADSAVEPRESETS);

    CleanUIConfig_AddControl(self, CUIConfig_SaveName);
    CleanUIConfig_AddControl(self, CUIConfig_LoadName);
    CleanUIConfig_AddControl(self, CUIConfig_Reset);

    -- ActionBars
    local actionBars = CreateFrame("Frame", "CUIConfigActionBars");
    actionBars.name = CONFIG_ACTIONBARS_TITLE;
    actionBars.parent = "CleanUI";
    actionBars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(actionBars);

    CleanUIConfig_CreateHeader(actionBars, CONFIG_ACTIONBARS_TITLE , CONFIG_ACTIONBARS_INFO);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleCleanActionBars",
        CONFIG_TOGGLECLEANACTIONBARS, CleanUIConfig_ToggleCleanActionBars);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleMacroNames",
        CONFIG_TOGGLEMACRONAMES, CleanUIConfig_ToggleMacroNames);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleActionButtonBorder",
        CONFIG_TOGGLEACTIONBUTTONBORDER, CleanUIConfig_ToggleActionButtonBorder);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleShapeshiftBarBorder",
        CONFIG_TOGGLESHAPESHIFTBARBORDER, CleanUIConfig_ToggleShapeshiftBarBorder);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_TogglePetActionBarBorder",
        CONFIG_TOGGLEPETACTIONBARBORDER, CleanUIConfig_TogglePetActionBarBorder);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleMasqueForActionButtons",
        CONFIG_TOGGLEMASQUEFORACTIONBUTTONS, CleanUIConfig_ToggleMasqueForActionButtons);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleRangeIndicatorForActionButtons",
        CONFIG_SHOW_RANGEINDICATOR, CleanUIConfig_ToggleRangeIndicatorForActionButtons);

    CleanUIConfig_AddCheckButton(actionBars, "CUIConfig_ToggleActionBarsComboPoints",
        COMBAT_TEXT_SHOW_COMBO_POINTS_TEXT, CleanUIConfig_ToggleActionBarsComboPoints);

    -- DeBuffs
    local debuffs = CreateFrame("Frame", "CUIConfigDeBuffs");
    debuffs.name = CONFIG_DEBUFFS_TITLE;
    debuffs.parent = "CleanUI";
    debuffs.addonname = "CleanUI";
    InterfaceOptions_AddCategory(debuffs);

    CleanUIConfig_CreateHeader(debuffs, CONFIG_DEBUFFS_TITLE , CONFIG_DEBUFFS_INFO);

    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleDeBuffsForActionButtons",
        CONFIG_TOGGLEDEBUFFSFORACTIONBUTTONS, CleanUIConfig_ToggleDeBuffsForActionButtons);

    CleanUIConfig_AddControl(debuffs, CleanUIDeBuffsBarColorExample);

    CleanUIConfig_AddSlider(debuffs, "CUIConfig_DeBuffsBarHeight",
        CONFIG_TOGGLEDEBUFFSFORACTIONBUTTONS_HEIGHT, 1, 8, 1, CleanUIConfig_SelectDeBuffsBarHeight);

    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleMasqueForBuffs",
        CONFIG_TOGGLEMASQUEFORBUFFS, CleanUIConfig_ToggleMasqueForBuffs);

    CleanUIConfig_AddCheckButton(debuffs, "CUIConfig_ToggleBiggerDebuffs",
        CONFIG_TOGGLEBIGGERDEBUFFS, CleanUIConfig_ToggleBiggerDebuffs);

    -- CastingBars
    local castingbars = CreateFrame("Frame", "CUIConfigCastingBars");
    castingbars.name = CONFIG_CASTINGBARS_TITLE;
    castingbars.parent = "CleanUI";
    castingbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(castingbars);

    CleanUIConfig_CreateHeader(castingbars, CONFIG_CASTINGBARS_TITLE , CONFIG_CASTINGBARS_INFO);

    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleChangeCastingBars",
        CONFIG_TOGGLECHANGECASTINGBARS, CleanUIConfig_ToggleChangeCastingBars);

    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowPetBar",
        CONFIG_TOGGLECASTINGBARS_PETBAR, CleanUIConfig_ToggleCastingBarsShowPetBar);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectCastingBarAlpha",
        CONFIG_TOGGLECASTINGBARALPHA, 0, 1, 0.01, CleanUIConfig_SelectCastingBarAlpha);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectCastingBarWidth",
        CONFIG_TOGGLECASTINGBARWIDTH, 100, 500, 1, CleanUIConfig_SelectCastingBarWidth);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPlayerCastingBarHeight",
        CONFIG_TOGGLEPLAYERCASTINGBARHEIGHT, 12, 64, 1, CleanUIConfig_SelectPlayerCastingBarHeight);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPlayerCastingBarImageSize",
        CONFIG_TOGGLEPLAYERCASTINGBARIMAGESIZE, 12, 64, 1, CleanUIConfig_SelectPlayerCastingBarImageSize);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectPetCastingBarHeight",
        CONFIG_TOGGLEPETCASTINGBARHEIGHT, 12, 64, 1, CleanUIConfig_SelectPetCastingBarHeight);

    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowGlobalCooldown",
        CONFIG_TOGGLESHOWGLOBALCOOLDOWN, CleanUIConfig_ToggleCastingBarsShowGlobalCooldown);

    CleanUIConfig_AddSlider(castingbars, "CUIConfig_SelectGlobalCooldownHeight",
        CONFIG_TOGGLEGLOBALCOOLDOWNHEIGHT, 1, 10, 1, CleanUIConfig_SelectGlobalCooldownHeight, 45);

    CleanUIConfig_AddCheckButton(castingbars, "CUIConfig_ToggleCastingBarsShowLatency",
        CONFIG_TOGGLESHOWLATENCY, CleanUIConfig_ToggleCastingBarsShowLatency);

    -- Minimap
    local minimap = CreateFrame("Frame", "CUIConfigMinimap");
    minimap.name = CONFIG_MINIMAP_TITLE;
    minimap.parent = "CleanUI";
    minimap.addonname = "CleanUI";
    InterfaceOptions_AddCategory(minimap);

    CleanUIConfig_CreateHeader(minimap, CONFIG_MINIMAP_TITLE , CONFIG_MINIMAP_INFO);

    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleCleanMinimap",
        CONFIG_TOGGLECLEANMINIMAP, CleanUIConfig_ToggleCleanMinimap);

    CleanUIConfig_AddSlider(minimap, "CUIConfig_SelectMinimapAlpha",
        CONFIG_TOGGLEMINIMAPALPHA, 0, 1, 0.01, CleanUIConfig_SelectMinimapAlpha);

    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleMinimapButtonBar",
        CONFIG_TOGGLEMINIMAPBUTTONBAR, CleanUIConfig_ToggleMinimapButtonBar);

    CleanUIConfig_AddCheckButton(minimap, "CUIConfig_ToggleWayPoints",
        CONFIG_TOGGLEWAYPOINTS, CleanUIConfig_ToggleWayPoints);

    CleanUIConfig_AddControl(minimap, CUILocationTextColor);

    -- UnitFrames
    local unitframes = CreateFrame("Frame", "CUIConfigUnitFrames");
    unitframes.name = CONFIG_UNITFRAMES_TITLE;
    unitframes.parent = "CleanUI";
    unitframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(unitframes);

    CleanUIConfig_CreateHeader(unitframes, CONFIG_UNITFRAMES_TITLE , CONFIG_UNITFRAMES_INFO);

    CleanUIConfig_AddCheckButton(unitframes, "CUIConfig_ToggleCleanUnitFrames",
        CONFIG_TOGGLECLEANUNITFRAMES, CleanUIConfig_ToggleCleanUnitFrames);

    CleanUIConfig_AddCheckButton(unitframes, "CUIConfig_ToggleCleanBossFrames",
        CONFIG_TOGGLECLEANBOSSFRAMES, CleanUIConfig_ToggleCleanBossFrames);

    CleanUIConfig_AddDropDown(unitframes, "CUIConfig_PortraitStyleDropDown",
        CONFIG_PORTRAITSTYLE, CUIConfig_PortraitStyleDropDown_Initialize, 200);

    -- RaidFrames
    local raidframes = CreateFrame("Frame", "CUIConfigRaidFrames");
    raidframes.name = CONFIG_RAID_TITLE;
    raidframes.parent = "CleanUI";
    raidframes.addonname = "CleanUI";
    InterfaceOptions_AddCategory(raidframes);

    CleanUIConfig_CreateHeader(raidframes, CONFIG_RAID_TITLE , CONFIG_RAID_INFO);

    CleanUIConfig_AddCheckButton(raidframes, "CUIConfig_ToggleChangeRaid",
        CONFIG_TOGGLECHANGERAID, CleanUIConfig_ToggleChangeRaid);

    -- XpBars
    local xpbars = CreateFrame("Frame", "CUIConfigXpBars");
    xpbars.name = CONFIG_XPBARS_TITLE;
    xpbars.parent = "CleanUI";
    xpbars.addonname = "CleanUI";
    InterfaceOptions_AddCategory(xpbars);

    CleanUIConfig_CreateHeader(xpbars, CONFIG_XPBARS_TITLE , CONFIG_XPBARS_INFO);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame",
        CONFIG_TOGGLEXPFRAME, CleanUIConfig_ToggleXpFrame);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleOrigXpBar",
        CONFIG_TOGGLE_ORIG_XPBAR, CleanUIConfig_ToggleOrigXpBar);

    CleanUIConfig_AddSlider(xpbars, "CUIConfig_SelectXpFrameWidth",
        CONFIG_TOGGLEXPFRAMEWIDTH, 100, 1000, 1, CleanUIConfig_SelectXpFrameWidth):SetWidth(300);

    CleanUIConfig_AddSlider(xpbars, "CUIConfig_SelectXpBarHeight",
        CONFIG_TOGGLEXPBARHEIGHT, 12, 45, 1, CleanUIConfig_SelectXpBarHeight):SetWidth(300);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_X_Xmax",
        CONFIG_TOGGLEXPFRAME_X_XMAX, CleanUIConfig_ToggleXpFrame_X_Xmax);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_Percent",
        CONFIG_TOGGLEXPFRAME_PERCENT, CleanUIConfig_ToggleXpFrame_Percent);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_MaxLevel",
        CONFIG_TOGGLEXPFRAME_MAXLEVEL, CleanUIConfig_ToggleXpFrame_MaxLevel);

    CleanUIConfig_AddCheckButton(xpbars, "CUIConfig_ToggleXpFrame_Unknown",
        CONFIG_TOGGLEXPFRAME_UNKNOWN, CleanUIConfig_ToggleXpFrame_Unknown);

    -- Bags
    local bags = CreateFrame("Frame", "CUIConfigBags");
    bags.name = CONFIG_BAGS_TITLE;
    bags.parent = "CleanUI";
    bags.addonname = "CleanUI";
    InterfaceOptions_AddCategory(bags);

    CleanUIConfig_CreateHeader(bags, CONFIG_BAGS_TITLE , CONFIG_BAGS_INFO);

    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleChangeBags",
        CONFIG_TOGGLECHANGEBAGS, CleanUIConfig_ToggleChangeBags);

    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleColorizeItems",
        CONFIG_TOGGLECOLORIZEBAGITEMS, CleanUIConfig_ToggleColorizeItems);

    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleShowWhiteAsGray",
        CONFIG_TOGGLESHOWWHITEASGRAY, CleanUIConfig_ToggleShowWhiteAsGray, 20, 45);

    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleBagsAutoRepair",
        CONFIG_TOGGLEAUTOREPAIR, CleanUIConfig_ToggleBagsAutoRepair);

    CleanUIConfig_AddCheckButton(bags, "CUIConfig_ToggleBagsAutoSellGray",
        CONFIG_TOGGLEAUTOSELLGRAY, CleanUIConfig_ToggleBagsAutoSellGray);

    -- Chat
    local chat = CreateFrame("Frame", "CUIConfigChat");
    chat.name = CONFIG_CHAT_TITLE;
    chat.parent = "CleanUI";
    chat.addonname = "CleanUI";
    InterfaceOptions_AddCategory(chat);

    CleanUIConfig_CreateHeader(chat, CONFIG_CHAT_TITLE , CONFIG_CHAT_INFO);

    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleChangeChat",
        CONFIG_TOGGLECHANGECHAT, CleanUIConfig_ToggleChangeChat);

    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleDisableAltArrowKeyMode",
        CONFIG_TOGGLEDISABLE_ALTARROWKEYMODE, CleanUIConfig_ToggleDisableAltArrowKeyMode);

    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleShowChatActionBar",
        CONFIG_TOGGLESHOWCHATACTIONBAR, CleanUIConfig_ToggleShowChatActionBar);

    CleanUIConfig_AddCheckButton(chat, "CUIConfig_ToggleShowChatEmoticons",
        CONFIG_TOGGLESHOWCHATEMOTICONS, CleanUIConfig_ToggleShowChatEmoticons);

    CleanUIConfig_AddSlider(chat, "CUIConfig_SelectChatFontSize",
        FONT_SIZE, 7, 36, 1, CleanUIConfig_SelectChatFontSize);


    -- Tooltips
    local tooltips = CreateFrame("Frame", "CUIConfigTooltips");
    tooltips.name = CONFIG_TOOLTIP_TITLE;
    tooltips.parent = "CleanUI";
    tooltips.addonname = "CleanUI";
    InterfaceOptions_AddCategory(tooltips);

    CleanUIConfig_CreateHeader(tooltips, CONFIG_TOOLTIP_TITLE , CONFIG_TOOLTIP_INFO);

    CleanUIConfig_AddCheckButton(tooltips, "CUIConfig_ToggleTooltipsBackdrop",
        CONFIG_TOOLTIP_BACKDROP, CleanUIConfig_ToggleTooltipsBackdrop);

    CleanUIConfig_AddCheckButton(tooltips, "CUIConfig_ToggleHideTooltipsInCombat",
        CONFIG_TOOLTIP_HIDE_IN_COMBAT, CleanUIConfig_ToggleHideTooltipsInCombat);

    CleanUIConfig_AddDropDown(tooltips, "CUIConfig_TooltipPositionDropDown",
        CONFIG_TOOLTIP_POSITION_LABEL, CUIConfig_TooltipPositionDropDown_Initialize, 175);

    -- Nameplates
    local nameplates = CreateFrame("Frame", "CUIConfigNameplates");
    nameplates.name = CONFIG_NAMEPLATES_TITLE;
    nameplates.parent = "CleanUI";
    nameplates.addonname = "CleanUI";
    InterfaceOptions_AddCategory(nameplates);

    CleanUIConfig_CreateHeader(nameplates, CONFIG_NAMEPLATES_TITLE , CONFIG_NAMEPLATES_INFO);

    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleChangeNameplates",
        CONFIG_TOGGLECHANGENAMEPLATES, CleanUIConfig_ToggleChangeNameplates);

    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesPercent",
        CONFIG_TOGGLENAMEPLATES_PERCENT, CleanUIConfig_ToggleNameplatesPercent);

    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesHighlightTarget",
        CONFIG_TOGGLENAMEPLATES_HIGHLIGHTTARGET, CleanUIConfig_ToggleNameplatesHighlightTarget);

    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesComboPoints",
        COMBAT_TEXT_SHOW_COMBO_POINTS_TEXT, CleanUIConfig_ToggleNameplatesComboPoints);

    CleanUIConfig_AddCheckButton(nameplates, "CUIConfig_ToggleNameplatesCombatOnly",
        CONFIG_TOGGLENAMEPLATES_COMBATONLY, CleanUIConfig_ToggleNameplatesCombatOnly);

    -- DataBroker
    local plugins = CreateFrame("Frame", "CUIConfigDataBroker");
    plugins.name = CONFIG_DATABROKER_TITLE;
    plugins.parent = "CleanUI";
    plugins.addonname = "CleanUI";
    InterfaceOptions_AddCategory(plugins);

    CleanUIConfig_CreateHeader(plugins, CONFIG_DATABROKER_TITLE , CONFIG_DATABROKER_INFO);

    CleanUIConfig_AddCheckButton(plugins, "CUIConfig_ToggleShowDataBroker",
        CONFIG_TOGGLESHOWDATABROKER, CleanUIConfig_ToggleShowDataBroker);

    CleanUIConfig_AddSlider(plugins, "CUIConfig_SelectDataBrokerCountRows",
        CONFIG_DATABROKER_COUNTROWS, 1, 20, 1, CleanUIConfig_SelectDataBrokerCountRows);
end

function CleanUIConfig_CreateHeader(parent, title, info)
    local headline, subtext;

    headline = parent:CreateFontString(parent:GetName().."Title", "ARTWORK", "CUIOptionsTitleTemplate");
    headline:SetText("|c333399ff"..title.."|r");
    headline:ClearAllPoints();
    headline:SetPoint("TOPLEFT", parent, "TOPLEFT", 16, -16);

    subtext = parent:CreateFontString(parent:GetName().."SubText", "ARTWORK", "CUIOptionsSubTextTemplate");
    subtext:SetText(info);
    subtext:ClearAllPoints();
    subtext:SetPoint("TOPLEFT", parent, "TOPLEFT", 16, -48);
    subtext:SetPoint("BOTTOMRIGHT", parent, "TOPRIGHT", -16, -85);
end

function CleanUIConfig_AddControl(parent, control, xoffset)

    control:SetParent(parent);

    local liste = controls[parent:GetName()];
    if (not liste) then
        liste = {};
        controls[parent:GetName()] = liste;
    end

    local size = table.getn(liste);

    if (xoffset) then
        control.xoffset = xoffset;
    end

    local ref = parent;
    local relative = "TOPLEFT";
    local x = 15 + (xoffset or 0);
    local y = -90;

    if (size > 0) then
        ref = liste[size];
        relative = "BOTTOMLEFT";
        x = (xoffset or 0) - (ref.xoffset or 0);
        y = -14;
    end

    table.insert(liste, control);

    control:ClearAllPoints();
    control:SetPoint("TOPLEFT", ref, relative, x, y);

    return control;
end

function CleanUIConfig_AddLabel(parent, name, text)
    local info = parent:CreateFontString(name, "ARTWORK");
    info:SetFontObject("GameFontNormal");
    info:SetWidth(450);
    info:SetHeight(50);
    info:SetJustifyH("LEFT");
    info:SetJustifyV("BOTTOM");
    info:SetText("|cffffffff"..text.."|r");

    return CleanUIConfig_AddControl(parent, info, 10);
end

function CleanUIConfig_AddCheckButton(parent, name, text, onClick, size, xoffset)
    local checkButton = CreateFrame("CheckButton", name, parent, "CUIOptionsCheckButtonTemplate");
    checkButton.text:SetText(text);

    checkButton:SetScript("OnClick", onClick);

    if (size) then
        checkButton:SetSize(size, size);
    end

    return CleanUIConfig_AddControl(parent, checkButton, xoffset);
end

function CleanUIConfig_AddSlider(parent, name, text, min, max, step, onValueChanged, xoffset)
    local slider = CreateFrame("Slider", name, parent, "CUIOptionsSliderTemplate");

    slider:SetScript("OnValueChanged", onValueChanged);

    slider:SetMinMaxValues(min, max);
    slider:SetValueStep(step);

    local label = _G[slider:GetName().."Text"];
    label:SetText(text);
    label:ClearAllPoints();
    label:SetPoint("LEFT", slider, "RIGHT", 15, 0);
    label:SetFontObject("GameFontNormal");

    local textLow = _G[slider:GetName().."Low"];
    local textHigh = _G[slider:GetName().."High"];
    textLow:SetText(min);
    textHigh:SetText(max);

    return CleanUIConfig_AddControl(parent, slider, xoffset);
end

function CleanUIConfig_AddDropDown(parent, name, text, onInitialize, width, xoffset)
    local dropdown = CreateFrame("Frame", name, parent, "CUIDropDownMenuTemplate");

    dropdown.label:SetText(text);

    UIDropDownMenu_Initialize(dropdown, onInitialize);
    UIDropDownMenu_JustifyText(dropdown, "LEFT");

    if (width) then
        UIDropDownMenu_SetWidth(dropdown, width);
    end

    return CleanUIConfig_AddControl(parent, dropdown, xoffset);
end

function CleanUIConfig_SaveNameChanged()
    CleanUIConfig_CheckSave();
end

function CleanUIConfig_CheckSave()
    local name = _G["CUIConfig_SaveName"]:GetText();

    if (not name or name == "") then
        _G["CUIConfig_Save"]:Disable();
    else
        _G["CUIConfig_Save"]:Enable();
    end
end

function CleanUIConfig_Save()
    local name = _G["CUIConfig_SaveName"]:GetText();
    if (name and name ~= "") then
        CleanUICommonData[name] = CleanUIData;
        UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_LoadName_Initialize()

    for name, data in pairs(CleanUICommonData) do
        local info = UIDropDownMenu_CreateInfo();
        info.text = name;
        info.value = data;
        info.func = function()
            CleanUIConfig_LoadName_Select(name);
        end
        UIDropDownMenu_AddButton(info);
    end
end

function CleanUIConfig_LoadName_Select(name)
    UIDropDownMenu_SetText(_G["CUIConfig_LoadName"], name);
end

function CleanUIConfig_Load()
    local name = UIDropDownMenu_GetText(_G["CUIConfig_LoadName"]);

    if (name) then
        CleanUIData = CleanUICommonData[name];
        CleanUIConfig_ConfigChanged();
        PlaySound("igInventoryOepn");
    end
end

function CleanUIConfig_VersionUpdate()

    if (not CleanUIData.VERSION) then
        CleanUIData.VERSION = 0;
    end

    -- �lter als Version 4.23
    if (CleanUIData.VERSION < 423) then
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI|r version update.", 1.0, 1.0, 1.0, 1, 10);
    end

    CleanUIData.VERSION = 502;
end

function CleanUIConfig_Init()
    CleanUIConfig_VersionUpdate();

    CleanUIConfig_CheckSave();

    CleanUIData.SCREENSHOT = CleanUIConfig_GetDefault(CleanUIData.SCREENSHOT, true);

    CleanUIData.STATUSBAR_STYLE = CleanUIConfig_GetDefault(CleanUIData.STATUSBAR_STYLE, 1);
    CleanUIData.CUI_STATUSBAR = CleanUIConfig_GetDefault(CleanUIData.CUI_STATUSBAR, "Interface\\AddOns\\CleanUI\\skins\\statusbars\\default");
    CleanUIData.CUI_STATUSBAR_VERTICAL = CleanUIConfig_GetDefault(CleanUIData.CUI_STATUSBAR_VERTICAL, "Interface\\AddOns\\CleanUI\\skins\\statusbars\\defaultVertical");

    CleanUIData.CHANGE_ACTIONBARS = CleanUIConfig_GetDefault(CleanUIData.CHANGE_ACTIONBARS, true);
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_SHOWMACRONAMES, false);
    CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER, true);
    CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER, true);
    CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER, true);
    CleanUIData.MASQUE_ACTIONBUTTONS = CleanUIConfig_GetDefault(CleanUIData.MASQUE_ACTIONBUTTONS, true);
    CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR, false);

    CleanUIData.ACTIONBARS_DEBUFFS = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_DEBUFFS, true);
    CleanUIData.ACTIONBARS_DEBUFFS_R = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_DEBUFFS_R, 1);
    CleanUIData.ACTIONBARS_DEBUFFS_G = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_DEBUFFS_G, 0);
    CleanUIData.ACTIONBARS_DEBUFFS_B = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_DEBUFFS_B, 0);
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT, 2);
    CleanUIData.MASQUE_BUFFS = CleanUIConfig_GetDefault(CleanUIData.MASQUE_BUFFS, true);
    CleanUIData.BIGGER_DEBUFFS = CleanUIConfig_GetDefault(CleanUIData.BIGGER_DEBUFFS, true);

    CleanUIData.CHANGE_BAGS = CleanUIConfig_GetDefault(CleanUIData.CHANGE_BAGS, true);
    CleanUIData.BAGS_COLORIZE_ITEMS = CleanUIConfig_GetDefault(CleanUIData.BAGS_COLORIZE_ITEMS, true);
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = CleanUIConfig_GetDefault(CleanUIData.BAGS_SHOW_WHITE_AS_GRAY, true);
    CleanUIData.BAGS_AUTOREPAIR = CleanUIConfig_GetDefault(CleanUIData.BAGS_AUTOREPAIR, true);
    CleanUIData.BAGS_AUTOSELLGRAY = CleanUIConfig_GetDefault(CleanUIData.BAGS_AUTOSELLGRAY, true);
    CleanUIData.BAGPACK_MINIMAP_POS = CleanUIConfig_GetDefault(CleanUIData.BAGPACK_MINIMAP_POS, 45);

    CleanUIData.CHANGE_CASTINGBARS = CleanUIConfig_GetDefault(CleanUIData.CHANGE_CASTINGBARS, true);
    CleanUIData.CASTINGBARS_SHOWPETBAR = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_SHOWPETBAR, true);
    CleanUIData.CASTINGBARS_ALPHA = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_ALPHA, 1);
    CleanUIData.CASTINGBARS_WIDTH = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_WIDTH, 300);
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_PLAYERHEIGHT, 24);
    CleanUIData.CASTINGBARS_IMAGESIZE = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_IMAGESIZE, 24);
    CleanUIData.CASTINGBARS_PETHEIGHT = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_PETHEIGHT, 16);
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN, true);
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT, 2);
    CleanUIData.CASTINGBARS_LATENCY = CleanUIConfig_GetDefault(CleanUIData.CASTINGBARS_LATENCY, true);

    CleanUIData.CHANGE_MINIMAP = CleanUIConfig_GetDefault(CleanUIData.CHANGE_MINIMAP, true);
    CleanUIData.MINIMAP_ALPHA = CleanUIConfig_GetDefault(CleanUIData.MINIMAP_ALPHA, 1);
    CleanUIData.WATCHFRAME_ALPHA = CleanUIConfig_GetDefault(CleanUIData.WATCHFRAME_ALPHA, 0.75);
    CleanUIData.MINIMAP_SHOWBUTTONBAR = CleanUIConfig_GetDefault(CleanUIData.MINIMAP_SHOWBUTTONBAR, true);
    CleanUIData.MINIMAP_RIGHTBUTTONS = CleanUIConfig_GetDefault(CleanUIData.MINIMAP_RIGHTBUTTONS, {});
    CleanUIData.MAP_SHOWWAYPOINTS = CleanUIConfig_GetDefault(CleanUIData.MAP_SHOWWAYPOINTS, true);
    CleanUIData.TLOC_R = CleanUIConfig_GetDefault(CleanUIData.TLOC_R, 1);
    CleanUIData.TLOC_G = CleanUIConfig_GetDefault(CleanUIData.TLOC_G, 1);
    CleanUIData.TLOC_B = CleanUIConfig_GetDefault(CleanUIData.TLOC_B, 1);

    CleanUIData.CHANGE_UNITFRAMES = CleanUIConfig_GetDefault(CleanUIData.CHANGE_UNITFRAMES, true);
    CleanUIData.CHANGE_BOSSFRAMES = CleanUIConfig_GetDefault(CleanUIData.CHANGE_BOSSFRAMES, true);
    CleanUIData.PORTRAIT_STYLE = CleanUIConfig_GetDefault(CleanUIData.PORTRAIT_STYLE, 0);
    CleanUIData.UNITFRAME_CUSTOM_POSITIONS = CleanUIConfig_GetDefault(CleanUIData.UNITFRAME_CUSTOM_POSITIONS, {});

    CleanUIData.SHOW_XPFRAME = CleanUIConfig_GetDefault(CleanUIData.SHOW_XPFRAME, false);
    CleanUIData.SHOW_ORIG_XPBAR = CleanUIConfig_GetDefault(CleanUIData.SHOW_ORIG_XPBAR, true);
    CleanUIData.XPFRAME_WIDTH = CleanUIConfig_GetDefault(CleanUIData.XPFRAME_WIDTH, 210);
    CleanUIData.XPBAR_HEIGHT = CleanUIConfig_GetDefault(CleanUIData.XPBAR_HEIGHT, 13);
    CleanUIData.XPFRAME_X_XMAX = CleanUIConfig_GetDefault(CleanUIData.XPFRAME_X_XMAX, true);
    CleanUIData.XPFRAME_PERCENT = CleanUIConfig_GetDefault(CleanUIData.XPFRAME_PERCENT, true);
    CleanUIData.XPFRAME_MAXLEVEL = CleanUIConfig_GetDefault(CleanUIData.XPFRAME_MAXLEVEL, false);
    CleanUIData.XPFRAME_UNKNOWN = CleanUIConfig_GetDefault(CleanUIData.XPFRAME_UNKNOWN, false);

    CleanUIData.CHANGE_CHAT = CleanUIConfig_GetDefault(CleanUIData.CHANGE_CHAT, true);
    CleanUIData.DISABLE_ALTARROWKEYMODE = CleanUIConfig_GetDefault(CleanUIData.DISABLE_ALTARROWKEYMODE, true);
    CleanUIData.SHOW_CHAT_ACTIONBAR = CleanUIConfig_GetDefault(CleanUIData.SHOW_CHAT_ACTIONBAR, true);
    CleanUIData.SHOW_CHAT_EMOTICONS = CleanUIConfig_GetDefault(CleanUIData.SHOW_CHAT_EMOTICONS, true);
    CleanUIData.CHAT_FONT_SIZE = CleanUIConfig_GetDefault(CleanUIData.CHAT_FONT_SIZE, 14);

    CleanUIData.CHANGE_RAID = CleanUIConfig_GetDefault(CleanUIData.CHANGE_RAID, true);

    CleanUIData.TOOLTIPS_HIDEINCOMBAT = CleanUIConfig_GetDefault(CleanUIData.TOOLTIPS_HIDEINCOMBAT, false);
    CleanUIData.TOOLTIPS_BACKDROP = CleanUIConfig_GetDefault(CleanUIData.TOOLTIPS_BACKDROP, true);
    CleanUIData.TOOLTIPS_POSITION = CleanUIConfig_GetDefault(CleanUIData.TOOLTIPS_POSITION, 1);

    CleanUIData.CHANGE_NAMEPLATES = CleanUIConfig_GetDefault(CleanUIData.CHANGE_NAMEPLATES, true);
    CleanUIData.NAMEPLATES_PERCENT = CleanUIConfig_GetDefault(CleanUIData.NAMEPLATES_PERCENT, true);
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = CleanUIConfig_GetDefault(CleanUIData.NAMEPLATES_HIGHLIGHTTARGET, true);
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = CleanUIConfig_GetDefault(CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS, true);
    CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS = CleanUIConfig_GetDefault(CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS, true);
    CleanUIData.NAMEPLATES_COMBATONLY = CleanUIConfig_GetDefault(CleanUIData.NAMEPLATES_COMBATONLY, false);

    CleanUIData.SHOW_DATABROKER = CleanUIConfig_GetDefault(CleanUIData.SHOW_DATABROKER, true);
    CleanUIData.DATABROKER_COUNTROWS = CleanUIConfig_GetDefault(CleanUIData.DATABROKER_COUNTROWS, 2);

    CleanUIData.DataBroker_Disabled = CleanUIConfig_GetDefault(CleanUIData.DataBroker_Disabled, {});

    UIDropDownMenu_Initialize(_G["CUIConfig_LoadName"], CleanUIConfig_LoadName_Initialize);

    CleanUIConfig_InitDataBroker();
end

function CleanUIConfig_GetDefault(value, default)
    if (value ~= nil) then
        return value;
    end

    return default;
end


function CleanUIConfig_InitDataBroker()

    local count = 0;
    local row = 0;
    local column = 0;

    local x_offset = 40;
    local y_offset = 40;

    local x, y;

    for name, button in pairs(db_buttons) do

        local dataobj = button.dataobj;

        local name = "CUIConfig_DataBroker_ToggleButton"..count;

        local checkbutton = _G[name];
        if (not checkbutton) then
            checkbutton = CreateFrame("CheckButton", name, CUIConfigDataBroker, "OptionsCheckButtonTemplate");
            checkbutton:SetWidth(32);
            checkbutton:SetHeight(32);
            checkbutton:SetHitRectInsets(0, 0, 0, 0);
            checkbutton:HookScript("OnEnter", CleanUIConfig_DataBroker_OnEnter);
            checkbutton:HookScript("OnLeave", CleanUIConfig_DataBroker_OnLeave);
            checkbutton:HookScript("OnClick", CleanUIConfig_DataBroker_OnClick);
        end

        checkbutton:SetParent(CUIConfigDataBroker);

        checkbutton:SetNormalTexture(dataobj.icon);
        checkbutton:SetPushedTexture(dataobj.icon);
        checkbutton:SetHighlightTexture(nil);
        checkbutton.dataobj = dataobj;

        column = mod(count, 10);
        if (column == 0) then
            row = row + 1;
        end

        x = column * x_offset;
        y = row * y_offset + 30;

        checkbutton:ClearAllPoints();
        checkbutton:SetPoint("TOPLEFT", CUIConfig_SelectDataBrokerCountRows, "TOPLEFT", x, -y);

        local checked = not CleanUIData.DataBroker_Disabled[dataobj.cui_name];
        checkbutton:SetChecked(checked);

        count = count + 1;
    end
end

function CleanUIConfig_DataBroker_OnClick(self)
    local dataobj = self.dataobj;
    local name = dataobj.cui_name;

    if (self:GetChecked()) then
        CleanUIData.DataBroker_Disabled[name] = false;
    else
        CleanUIData.DataBroker_Disabled[name] = true;
    end

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_DataBroker_OnEnter(self)
    local dataobj = self.dataobj;
    GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
    GameTooltip:SetText(dataobj.cui_name);
    GameTooltip:Show();
end

function CleanUIConfig_DataBroker_OnLeave()
    GameTooltip:FadeOut();
end

function CleanUIConfig_Reset()

    CleanUIData.SCREENSHOT = true;

    CleanUIData.STATUSBAR_STYLE = 1;
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\default";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\defaultVertical";

    CleanUIData.CHANGE_ACTIONBARS = true;
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = false;
    CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = true;
    CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = true;
    CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = true;
    CleanUIData.MASQUE_ACTIONBUTTONS = true;
    CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = false;

    CleanUIData.ACTIONBARS_DEBUFFS = true;
    CleanUIData.ACTIONBARS_DEBUFFS_R = 1;
    CleanUIData.ACTIONBARS_DEBUFFS_G = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_B = 0;
    CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = 2;
    CleanUIData.MASQUE_BUFFS = true;
    CleanUIData.BIGGER_DEBUFFS = true;

    CleanUIData.CHANGE_BAGS = true;
    CleanUIData.BAGS_COLORIZE_ITEMS = true;
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = true;
    CleanUIData.BAGS_AUTOREPAIR = true;
    CleanUIData.BAGS_AUTOSELLGRAY = true;
    CleanUIData.BAGPACK_MINIMAP_POS = 45;

    CleanUIData.CHANGE_CASTINGBARS = true;
    CleanUIData.CASTINGBARS_SHOWPETBAR = true;
    CleanUIData.CASTINGBARS_ALPHA = 1;
    CleanUIData.CASTINGBARS_WIDTH = 300;
    CleanUIData.CASTINGBARS_PLAYERHEIGHT = 24;
    CleanUIData.CASTINGBARS_IMAGESIZE = 24;
    CleanUIData.CASTINGBARS_PETHEIGHT = 16;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = true;
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = 2;
    CleanUIData.CASTINGBARS_LATENCY = true;

    CleanUIData.CHANGE_MINIMAP = true;
    CleanUIData.MINIMAP_ALPHA = 1;
    CleanUIData.WATCHFRAME_ALPHA = 0.75;
    CleanUIData.MINIMAP_SHOWBUTTONBAR = true;
    CleanUIData.MINIMAP_RIGHTBUTTONS = {};
    CleanUIData.MAP_SHOWWAYPOINTS = true;
    CleanUIData.TLOC_R = 1;
    CleanUIData.TLOC_G = 1;
    CleanUIData.TLOC_B = 1;

    CleanUIData.CHANGE_UNITFRAMES = true;
    CleanUIData.CHANGE_BOSSFRAMES = true;
    CleanUIData.PORTRAIT_STYLE = 0;
    CleanUIData.UNITFRAME_CUSTOM_POSITIONS = {};

    CleanUIData.SHOW_XPFRAME = false;
    CleanUIData.SHOW_ORIG_XPBAR = true;
    CleanUIData.XPFRAME_WIDTH = 210;
    CleanUIData.XPBAR_HEIGHT = 13;
    CleanUIData.XPFRAME_X_XMAX = true;
    CleanUIData.XPFRAME_PERCENT = true;
    CleanUIData.XPFRAME_MAXLEVEL = false;
    CleanUIData.XPFRAME_UNKNOWN = false;

    CleanUIData.CHANGE_CHAT = true;
    CleanUIData.DISABLE_ALTARROWKEYMODE = true;
    CleanUIData.SHOW_CHAT_ACTIONBAR = true;
    CleanUIData.SHOW_CHAT_EMOTICONS = true;
    CleanUIData.CHAT_FONT_SIZE = 14;

    CleanUIData.CHANGE_RAID = true;

    CleanUIData.TOOLTIPS_HIDEINCOMBAT = false;
    CleanUIData.TOOLTIPS_BACKDROP = true;
    CleanUIData.TOOLTIPS_POSITION = 1;

    CleanUIData.CHANGE_NAMEPLATES = true;
    CleanUIData.NAMEPLATES_PERCENT = true;
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = true;
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = true;
    CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS = true;
    CleanUIData.NAMEPLATES_COMBATONLY = false;

    CleanUIData.SHOW_DATABROKER = true;
    CleanUIData.DATABROKER_COUNTROWS = 2;

    CleanUIData.DataBroker_Disabled = {};

    -- initialize
    CleanUIConfig_Init();
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ConfigChanged()
    InterfaceOptionsFrame.gameRestart = true;
    CleanUIConfig_ReloadConfig();
end

function CleanUIConfig_ReloadConfig()

    if (not cui_config_loaded) then
        return;
    end

    CleanUIConfig_Init();

    _G["CUIConfig_ToggleScreenshot"]:SetChecked(CleanUIData.SCREENSHOT);

    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_StatusBarStyleDropDown"], CleanUIData.STATUSBAR_STYLE);
    UIDropDownMenu_SetText(_G["CUIConfig_StatusBarStyleDropDown"], STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE]);

    _G["CUIConfig_ToggleCleanActionBars"]:SetChecked(CleanUIData.CHANGE_ACTIONBARS);
    _G["CUIConfig_ToggleMacroNames"]:SetChecked(CleanUIData.ACTIONBARS_SHOWMACRONAMES);
    _G["CUIConfig_ToggleActionButtonBorder"]:SetChecked(CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER);
    _G["CUIConfig_ToggleShapeshiftBarBorder"]:SetChecked(CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER);
    _G["CUIConfig_TogglePetActionBarBorder"]:SetChecked(CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER);
    _G["CUIConfig_ToggleMasqueForActionButtons"]:SetChecked(CleanUIData.MASQUE_ACTIONBUTTONS);
    _G["CUIConfig_ToggleRangeIndicatorForActionButtons"]:SetChecked(CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR);

    _G["CUIConfig_ToggleDeBuffsForActionButtons"]:SetChecked(CleanUIData.ACTIONBARS_DEBUFFS);
    _G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
    _G["CUIConfig_DeBuffsBarHeight"]:SetValue(CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT);
    _G["CUIConfig_DeBuffsBarHeightValue"]:SetText(format("%.0f", CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT));
    _G["CUIConfig_ToggleMasqueForBuffs"]:SetChecked(CleanUIData.MASQUE_BUFFS);
    _G["CUIConfig_ToggleBiggerDebuffs"]:SetChecked(CleanUIData.BIGGER_DEBUFFS);

    _G["CUIConfig_ToggleChangeBags"]:SetChecked(CleanUIData.CHANGE_BAGS);
    _G["CUIConfig_ToggleColorizeItems"]:SetChecked(CleanUIData.BAGS_COLORIZE_ITEMS);
    _G["CUIConfig_ToggleShowWhiteAsGray"]:SetChecked(CleanUIData.BAGS_SHOW_WHITE_AS_GRAY);
    _G["CUIConfig_ToggleBagsAutoRepair"]:SetChecked(CleanUIData.BAGS_AUTOREPAIR);
    _G["CUIConfig_ToggleBagsAutoSellGray"]:SetChecked(CleanUIData.BAGS_AUTOSELLGRAY);

    _G["CUIConfig_ToggleChangeCastingBars"]:SetChecked(CleanUIData.CHANGE_CASTINGBARS);
    _G["CUIConfig_ToggleCastingBarsShowPetBar"]:SetChecked(CleanUIData.CASTINGBARS_SHOWPETBAR);
    _G["CUIConfig_SelectCastingBarAlpha"]:SetValue(CleanUIData.CASTINGBARS_ALPHA);
    _G["CUIConfig_SelectCastingBarAlphaValue"]:SetText(format("%.2f", CleanUIData.CASTINGBARS_ALPHA));
    _G["CUIConfig_SelectCastingBarWidth"]:SetValue(CleanUIData.CASTINGBARS_WIDTH);
    _G["CUIConfig_SelectCastingBarWidthValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_WIDTH));
    _G["CUIConfig_SelectPlayerCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PLAYERHEIGHT);
    _G["CUIConfig_SelectPlayerCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PLAYERHEIGHT));
    _G["CUIConfig_SelectPlayerCastingBarImageSize"]:SetValue(CleanUIData.CASTINGBARS_IMAGESIZE);
    _G["CUIConfig_SelectPlayerCastingBarImageSizeValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_IMAGESIZE));
    _G["CUIConfig_SelectPetCastingBarHeight"]:SetValue(CleanUIData.CASTINGBARS_PETHEIGHT);
    _G["CUIConfig_SelectPetCastingBarHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_PETHEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowGlobalCooldown"]:SetChecked(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN);
    _G["CUIConfig_SelectGlobalCooldownHeight"]:SetValue(CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT);
    _G["CUIConfig_SelectGlobalCooldownHeightValue"]:SetText(format("%.0f", CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT));
    _G["CUIConfig_ToggleCastingBarsShowLatency"]:SetChecked(CleanUIData.CASTINGBARS_LATENCY);

    _G["CUIConfig_ToggleCleanMinimap"]:SetChecked(CleanUIData.CHANGE_MINIMAP);
    _G["CUIConfig_SelectMinimapAlpha"]:SetValue(CleanUIData.MINIMAP_ALPHA);
    _G["CUIConfig_SelectMinimapAlphaValue"]:SetText(format("%.2f", CleanUIData.MINIMAP_ALPHA));
    _G["CUIConfig_SelectWatchFrameAlpha"]:SetValue(CleanUIData.WATCHFRAME_ALPHA);
    _G["CUIConfig_SelectWatchFrameAlphaValue"]:SetText(format("%.2f", CleanUIData.WATCHFRAME_ALPHA));
    _G["CUIConfig_ToggleMinimapButtonBar"]:SetChecked(CleanUIData.MINIMAP_SHOWBUTTONBAR);
    _G["CUIConfig_ToggleWayPoints"]:SetChecked(CleanUIData.MAP_SHOWWAYPOINTS);
    _G["CUILocationTextColor"]:SetBackdropColor(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);

    _G["CUIConfig_ToggleCleanUnitFrames"]:SetChecked(CleanUIData.CHANGE_UNITFRAMES);
    _G["CUIConfig_ToggleCleanBossFrames"]:SetChecked(CleanUIData.CHANGE_BOSSFRAMES);

    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_PortraitStyleDropDown"], CleanUIData.PORTRAIT_STYLE);
    UIDropDownMenu_SetText(_G["CUIConfig_PortraitStyleDropDown"], PORTRAIT_TYPE[CleanUIData.PORTRAIT_STYLE]);

    _G["CUIConfig_ToggleXpFrame"]:SetChecked(CleanUIData.SHOW_XPFRAME);
    _G["CUIConfig_ToggleOrigXpBar"]:SetChecked(CleanUIData.SHOW_ORIG_XPBAR);
    _G["CUIConfig_SelectXpFrameWidth"]:SetValue(CleanUIData.XPFRAME_WIDTH);
    _G["CUIConfig_SelectXpFrameWidthValue"]:SetText(format("%.0f", CleanUIData.XPFRAME_WIDTH));
    _G["CUIConfig_SelectXpBarHeight"]:SetValue(CleanUIData.XPBAR_HEIGHT);
    _G["CUIConfig_SelectXpBarHeightValue"]:SetText(format("%.0f", CleanUIData.XPBAR_HEIGHT));
    _G["CUIConfig_ToggleXpFrame_X_Xmax"]:SetChecked(CleanUIData.XPFRAME_X_XMAX);
    _G["CUIConfig_ToggleXpFrame_Percent"]:SetChecked(CleanUIData.XPFRAME_PERCENT);
    _G["CUIConfig_ToggleXpFrame_MaxLevel"]:SetChecked(CleanUIData.XPFRAME_MAXLEVEL);
    _G["CUIConfig_ToggleXpFrame_Unknown"]:SetChecked(CleanUIData.XPFRAME_UNKNOWN);

    _G["CUIConfig_ToggleChangeChat"]:SetChecked(CleanUIData.CHANGE_CHAT);
    _G["CUIConfig_ToggleDisableAltArrowKeyMode"]:SetChecked(CleanUIData.DISABLE_ALTARROWKEYMODE);
    _G["CUIConfig_ToggleShowChatActionBar"]:SetChecked(CleanUIData.SHOW_CHAT_ACTIONBAR);
    _G["CUIConfig_ToggleShowChatEmoticons"]:SetChecked(CleanUIData.SHOW_CHAT_EMOTICONS);
    _G["CUIConfig_SelectChatFontSize"]:SetValue(CleanUIData.CHAT_FONT_SIZE);
    _G["CUIConfig_SelectChatFontSizeValue"]:SetText(format("%.0f", CleanUIData.CHAT_FONT_SIZE));

    _G["CUIConfig_ToggleChangeRaid"]:SetChecked(CleanUIData.CHANGE_RAID);

    _G["CUIConfig_ToggleChangeNameplates"]:SetChecked(CleanUIData.CHANGE_NAMEPLATES);
    _G["CUIConfig_ToggleNameplatesPercent"]:SetChecked(CleanUIData.NAMEPLATES_PERCENT);
    _G["CUIConfig_ToggleNameplatesHighlightTarget"]:SetChecked(CleanUIData.NAMEPLATES_HIGHLIGHTTARGET);
    _G["CUIConfig_ToggleNameplatesComboPoints"]:SetChecked(CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS);
    _G["CUIConfig_ToggleActionBarsComboPoints"]:SetChecked(CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS);
    _G["CUIConfig_ToggleNameplatesCombatOnly"]:SetChecked(CleanUIData.NAMEPLATES_COMBATONLY);

    _G["CUIConfig_ToggleShowDataBroker"]:SetChecked(CleanUIData.SHOW_DATABROKER);
    _G["CUIConfig_SelectDataBrokerCountRows"]:SetValue(CleanUIData.DATABROKER_COUNTROWS);
    _G["CUIConfig_SelectDataBrokerCountRowsValue"]:SetText(format("%.0f", CleanUIData.DATABROKER_COUNTROWS));

    if (CleanUIData.CHANGE_ACTIONBARS) then
        _G["CUIConfig_ToggleOrigXpBar"]:Enable();
    else
        _G["CUIConfig_ToggleOrigXpBar"]:Disable();
    end

    if (CleanUIData.BAGS_COLORIZE_ITEMS) then
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Enable();
    else
        _G["CUIConfig_ToggleShowWhiteAsGray"]:Disable();
    end

    UIDropDownMenu_SetSelectedValue(_G["CUIConfig_TooltipPositionDropDown"], CleanUIData.TOOLTIPS_POSITION);
    UIDropDownMenu_SetText(_G["CUIConfig_TooltipPositionDropDown"], TOOLTIPS_POSITION[CleanUIData.TOOLTIPS_POSITION]);
    _G["CUIConfig_ToggleHideTooltipsInCombat"]:SetChecked(CleanUIData.TOOLTIPS_HIDEINCOMBAT);
    _G["CUIConfig_ToggleTooltipsBackdrop"]:SetChecked(CleanUIData.TOOLTIPS_BACKDROP);

    -- update the ui
    CleanUIConfig_InitBorderStyle();
    CleanUIConfig_InitStatusBarStyle();

    CleanUI_MoveBagButtons();
    CleanUI_DataBroker_ShowButtons();
    CleanUI_MainMenuBar_UpdateArt();
    CleanUI_StanceBar_UpdateState();
    CleanUI_PetActionBar_Update();
    CleanUI_UpdateMinimap();

    CleanUI_UpdateChatFontSize();

    CleanUI_UpdateWatchFrameAlpha();

    CleanUI_CheckActivateNameplates();
end

function CleanUIConfig_InitBorderStyle()
    CleanUI_ReplaceAllBorderTextures("UI-Tooltip-Border", UIParent);
    CleanUI_ReplaceAllBorderTextures("frame-border", UIParent);
end

function CleanUIConfig_InitStatusBarStyle()
    CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\default";
    CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\defaultVertical";

    if (CleanUIData.STATUSBAR_STYLE >= 2) then
        CleanUIData.CUI_STATUSBAR = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE];
        CleanUIData.CUI_STATUSBAR_VERTICAL = "Interface\\AddOns\\CleanUI\\skins\\statusbars\\"..STATUSBAR_STYLE[CleanUIData.STATUSBAR_STYLE].."Vertical";
    end

    CleanUI_InitStatusBarTexture();
end

function CUIConfig_StatusBarStyleDropDown_Initialize(self)
    local selectedValue = UIDropDownMenu_GetSelectedValue(self);

    for i = 1, #STATUSBAR_STYLE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = STATUSBAR_STYLE[i];
        info.value = i;
        info.func = function()
            CleanUIConfig_ToggleStatusBarStyle(i);
        end
        UIDropDownMenu_AddButton(info);
    end
end

function CUIConfig_TooltipPositionDropDown_Initialize(self)
    local selectedValue = UIDropDownMenu_GetSelectedValue(self);

    for i = 1, #TOOLTIPS_POSITION do
        local info = UIDropDownMenu_CreateInfo();
        info.text = TOOLTIPS_POSITION[i];
        info.value = i;
        info.func = function()
            CleanUIConfig_ToggleTooltipPosition(i);
        end
        UIDropDownMenu_AddButton(info);
    end
end

function CleanUIConfig_InterfaceOptionsFrame_Show()
    if ( InterfaceOptionsFrame:IsShown() ) then
        CleanUIConfig_ReloadConfig();
    end

    CUI_CONFIG_SHOWN = true;
end

function CleanUIConfig_InterfaceOptionsFrame_Hide()
    CUI_CONFIG_SHOWN = false;

    -- Aufräumen!
    CleanUI_HideCastingBars();
end

function CleanUIConfig_OnEvent(self, event, ...)
    if (event == "CVAR_UPDATE") then
        local name, value = ...;
    --DEFAULT_CHAT_FRAME:AddMessage("CVAR_UPDATE   "..name.." = "..value, 1.0, 1.0, 1.0, 1, 10);
    end
end

-- settings

function CleanUIConfig_ToggleTooltipPosition(index)
    CleanUIData.TOOLTIPS_POSITION = index;
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleStatusBarStyle(index)
    CleanUIData.STATUSBAR_STYLE = index;
    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleScreenshot()
    CleanUIData.SCREENSHOT = not CleanUIData.SCREENSHOT;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleXpFrame()
    CleanUIData.SHOW_XPFRAME = not CleanUIData.SHOW_XPFRAME;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleOrigXpBar()
    CleanUIData.SHOW_ORIG_XPBAR = not CleanUIData.SHOW_ORIG_XPBAR;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_SelectXpFrameWidth(self)

    if (CleanUIData.XPFRAME_WIDTH ~= self:GetValue()) then
        CleanUIData.XPFRAME_WIDTH = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_SelectXpBarHeight(self)

    if (CleanUIData.XPBAR_HEIGHT ~= self:GetValue()) then
        CleanUIData.XPBAR_HEIGHT = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CleanUIXpFrame) then
            CleanUI_CleanXpFrame();
        end
    end
end

function CleanUIConfig_ToggleXpFrame_X_Xmax()
    CleanUIData.XPFRAME_X_XMAX = not CleanUIData.XPFRAME_X_XMAX;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Percent()
    CleanUIData.XPFRAME_PERCENT = not CleanUIData.XPFRAME_PERCENT;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_MaxLevel()
    CleanUIData.XPFRAME_MAXLEVEL = not CleanUIData.XPFRAME_MAXLEVEL;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleXpFrame_Unknown()
    CleanUIData.XPFRAME_UNKNOWN = not CleanUIData.XPFRAME_UNKNOWN;

    CleanUIConfig_ConfigChanged();
    CleanUI_CleanXpFrame();
end

function CleanUIConfig_ToggleCleanActionBars()
    CleanUIData.CHANGE_ACTIONBARS = not CleanUIData.CHANGE_ACTIONBARS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMacroNames()
    CleanUIData.ACTIONBARS_SHOWMACRONAMES = not CleanUIData.ACTIONBARS_SHOWMACRONAMES;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleDeBuffsForActionButtons()
    CleanUIData.ACTIONBARS_DEBUFFS = not CleanUIData.ACTIONBARS_DEBUFFS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDeBuffsColor()
    ColorPickerFrame.func = CleanUIConfig_SetDeBuffsColor;
    ColorPickerFrame:SetColorRGB(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
    ShowUIPanel(ColorPickerFrame);
end

function CleanUIConfig_SetDeBuffsColor()
    local r,g,b = ColorPickerFrame:GetColorRGB();
    CleanUIData.ACTIONBARS_DEBUFFS_R = r;
    CleanUIData.ACTIONBARS_DEBUFFS_G = g;
    CleanUIData.ACTIONBARS_DEBUFFS_B = b;

    _G["CleanUIDeBuffsBarColorExample"]:SetStatusBarColor(CleanUIData.ACTIONBARS_DEBUFFS_R, CleanUIData.ACTIONBARS_DEBUFFS_G, CleanUIData.ACTIONBARS_DEBUFFS_B);
end

function CleanUIConfig_SelectLocationTextColor()
    ColorPickerFrame.func = CleanUIConfig_SetLocationTextColor;
    ColorPickerFrame:SetColorRGB(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
    ShowUIPanel(ColorPickerFrame);
end

function CleanUIConfig_SetLocationTextColor()
    local r,g,b = ColorPickerFrame:GetColorRGB();
    CleanUIData.TLOC_R = r;
    CleanUIData.TLOC_G = g;
    CleanUIData.TLOC_B = b;

    _G["CUILocationTextColor"]:SetBackdropColor(CleanUIData.TLOC_R, CleanUIData.TLOC_G, CleanUIData.TLOC_B);
end

function CleanUIConfig_ToggleShapeshiftBarBorder()
    CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER = not CleanUIData.ACTIONBARS_SHAPESHIFTBAR_BORDER;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleActionButtonBorder()
    CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER = not CleanUIData.ACTIONBARS_ACTIONBUTTON_BORDER;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_TogglePetActionBarBorder()
    CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER = not CleanUIData.ACTIONBARS_PETACTIONBAR_BORDER;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMasqueForActionButtons()
    CleanUIData.MASQUE_ACTIONBUTTONS = not CleanUIData.MASQUE_ACTIONBUTTONS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleRangeIndicatorForActionButtons()
    CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR = not CleanUIData.ACTIONBARS_SHOWRANGEINDICATOR;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleMasqueForBuffs()
    CleanUIData.MASQUE_BUFFS = not CleanUIData.MASQUE_BUFFS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBiggerDebuffs()
    CleanUIData.BIGGER_DEBUFFS = not CleanUIData.BIGGER_DEBUFFS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeBags()
    CleanUIData.CHANGE_BAGS = not CleanUIData.CHANGE_BAGS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleColorizeItems()
    CleanUIData.BAGS_COLORIZE_ITEMS = not CleanUIData.BAGS_COLORIZE_ITEMS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowWhiteAsGray()
    CleanUIData.BAGS_SHOW_WHITE_AS_GRAY = not CleanUIData.BAGS_SHOW_WHITE_AS_GRAY;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoRepair()
    CleanUIData.BAGS_AUTOREPAIR = not CleanUIData.BAGS_AUTOREPAIR;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleBagsAutoSellGray()
    CleanUIData.BAGS_AUTOSELLGRAY = not CleanUIData.BAGS_AUTOSELLGRAY;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeCastingBars()
    CleanUIData.CHANGE_CASTINGBARS = not CleanUIData.CHANGE_CASTINGBARS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowPetBar()
    CleanUIData.CASTINGBARS_SHOWPETBAR = not CleanUIData.CASTINGBARS_SHOWPETBAR;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectCastingBarAlpha(self)

    if (CleanUIData.CASTINGBARS_ALPHA ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_ALPHA = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectDeBuffsBarHeight(self)

    if (CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT ~= self:GetValue()) then
        CleanUIData.ACTIONBARS_DEBUFFS_HEIGHT = self:GetValue();

        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectCastingBarWidth(self)

    if (CleanUIData.CASTINGBARS_WIDTH ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_WIDTH = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CastingBarFrame and CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PLAYERHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PLAYERHEIGHT = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPlayerCastingBarImageSize(self)

    if (CleanUIData.CASTINGBARS_IMAGESIZE ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_IMAGESIZE = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectPetCastingBarHeight(self)

    if (CleanUIData.CASTINGBARS_PETHEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_PETHEIGHT = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_SelectGlobalCooldownHeight(self)

    if (CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT ~= self:GetValue()) then
        CleanUIData.CASTINGBARS_GLOBALCOOLDOWN_HEIGHT = self:GetValue();

        CleanUIConfig_ConfigChanged();

        if (CleanUIPetCastingBarFrame) then
            CleanUI_UpdateCastingBars();
        end
    end
end

function CleanUIConfig_ToggleCleanMinimap()
    CleanUIData.CHANGE_MINIMAP = not CleanUIData.CHANGE_MINIMAP;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectMinimapAlpha(self)

    if (CleanUIData.MINIMAP_ALPHA ~= self:GetValue()) then
        CleanUIData.MINIMAP_ALPHA = self:GetValue();

        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_SelectWatchFrameAlpha(self)

    if (CleanUIData.WATCHFRAME_ALPHA ~= self:GetValue()) then
        CleanUIData.WATCHFRAME_ALPHA = self:GetValue();

        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_ToggleMinimapButtonBar()
    CleanUIData.MINIMAP_SHOWBUTTONBAR = not CleanUIData.MINIMAP_SHOWBUTTONBAR;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanUnitFrames()
    CleanUIData.CHANGE_UNITFRAMES = not CleanUIData.CHANGE_UNITFRAMES;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCleanBossFrames()
    CleanUIData.CHANGE_BOSSFRAMES = not CleanUIData.CHANGE_BOSSFRAMES;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowGlobalCooldown(self)
    CleanUIData.CASTINGBARS_GLOBALCOOLDOWN = not CleanUIData.CASTINGBARS_GLOBALCOOLDOWN;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleCastingBarsShowLatency(self)
    CleanUIData.CASTINGBARS_LATENCY = not CleanUIData.CASTINGBARS_LATENCY;

    CleanUIConfig_ConfigChanged();
end

function CUIConfig_PortraitStyleDropDown_Initialize(self)
    for i = 1, #PORTRAIT_TYPE do
        local info = UIDropDownMenu_CreateInfo();
        info.text = PORTRAIT_TYPE[i];
        info.value = i;
        info.func = function()
            CUIConfig_SelectPortraitStyle(i);
        end
        UIDropDownMenu_AddButton(info);
    end
end

function CUIConfig_SelectPortraitStyle(index)
    CleanUIData.PORTRAIT_STYLE = index;
    UIDropDownMenu_SetSelectedValue(CUIConfig_PortraitStyleDropDown, index);

    CleanUIConfig_ConfigChanged();
    CleanUI_UpdateAllPortraits();
end

function CleanUIConfig_ToggleWayPoints()
    CleanUIData.MAP_SHOWWAYPOINTS = not CleanUIData.MAP_SHOWWAYPOINTS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeChat()
    CleanUIData.CHANGE_CHAT = not CleanUIData.CHANGE_CHAT;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleDisableAltArrowKeyMode()
    CleanUIData.DISABLE_ALTARROWKEYMODE = not CleanUIData.DISABLE_ALTARROWKEYMODE;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatActionBar()
    CleanUIData.SHOW_CHAT_ACTIONBAR = not CleanUIData.SHOW_CHAT_ACTIONBAR;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowChatEmoticons()
    CleanUIData.SHOW_CHAT_EMOTICONS = not CleanUIData.SHOW_CHAT_EMOTICONS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectChatFontSize(self)
    if (CleanUIData.CHAT_FONT_SIZE ~= self:GetValue()) then
        CleanUIData.CHAT_FONT_SIZE = self:GetValue();

        CleanUIConfig_ConfigChanged();
    end
end

function CleanUIConfig_ToggleChangeRaid()
    CleanUIData.CHANGE_RAID = not CleanUIData.CHANGE_RAID;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleHideTooltipsInCombat()
    CleanUIData.TOOLTIPS_HIDEINCOMBAT = not CleanUIData.TOOLTIPS_HIDEINCOMBAT;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleTooltipsBackdrop()
    CleanUIData.TOOLTIPS_BACKDROP = not CleanUIData.TOOLTIPS_BACKDROP;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleChangeNameplates()
    CleanUIData.CHANGE_NAMEPLATES = not CleanUIData.CHANGE_NAMEPLATES;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesPercent()
    CleanUIData.NAMEPLATES_PERCENT = not CleanUIData.NAMEPLATES_PERCENT;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesHighlightTarget()
    CleanUIData.NAMEPLATES_HIGHLIGHTTARGET = not CleanUIData.NAMEPLATES_HIGHLIGHTTARGET;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesComboPoints()
    CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS = not CleanUIData.NAMEPLATES_SHOWCOMBOPOINTS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleActionBarsComboPoints()
    CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS = not CleanUIData.ACTIONBARS_SHOWCOMBOPOINTS;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleNameplatesCombatOnly()
    CleanUIData.NAMEPLATES_COMBATONLY = not CleanUIData.NAMEPLATES_COMBATONLY;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_ToggleShowDataBroker()
    CleanUIData.SHOW_DATABROKER = not CleanUIData.SHOW_DATABROKER;

    CleanUIConfig_ConfigChanged();
end

function CleanUIConfig_SelectDataBrokerCountRows(self)

    if (CleanUIData.DATABROKER_COUNTROWS ~= self:GetValue()) then
        CleanUIData.DATABROKER_COUNTROWS = self:GetValue();

        CleanUIConfig_ConfigChanged();
    end
end
