function CleanUI_InitClassTrainerFrame()
    CleanUI_ClassTrainerFrameHookEvents();
    CleanUI_RegisterClassTrainerFrameEvents();
end

function CleanUI_RegisterClassTrainerFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_ClassTrainerFrameOnEvent);
end

function CleanUI_ClassTrainerFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_TrainerUI" ) then
            CleanUI_CleanClassTrainerFrame();
        end
    end
end

function CleanUI_ClassTrainerFrameHookEvents()
--hooksecurefunc("xx", CleanUI_xx);
end

function CleanUI_CleanClassTrainerFrame()
    CleanUI_RemoveTextures(ClassTrainerFrame);
    CleanUI_SetBackdrop(ClassTrainerFrame);

    ClassTrainerFrame:SetHeight(447);
    CLASS_TRAINER_SCROLL_HEIGHT = 350;

    CleanUI_RemoveTextures(ClassTrainerFrameInset);

    CleanUI_RemoveTextures(ClassTrainerFrameBottomInset);

    ClassTrainerScrollFrameScrollBarBG:Hide();
    ClassTrainerScrollFrameScrollBarTop:Hide();
    ClassTrainerScrollFrameScrollBarBottom:Hide();
    ClassTrainerScrollFrameScrollBarMiddle:Hide();

    ClassTrainerFramePortrait:Hide();

    CleanUI_ChangeCloseButton(ClassTrainerFrame);

    CleanUI_CreateHeaderFrame(ClassTrainerFrame, "CUI_ClassTrainerFrameHeaderBorderframe", 250, ClassTrainerFrameTitleText);

    CleanUI_ChangeButton(ClassTrainerTrainButton);

    ClassTrainerStatusBar:SetHeight(20);
    ClassTrainerStatusBar:SetPoint("TOPLEFT", 64, -34);

    CleanUI_ChangeDropDown(ClassTrainerFrameFilterDropDown);
end
