local oldname = nil;

function CleanUI_InitEquipmentSets()
    CleanUI_EquipmentSetsHookEvents();
end

function CleanUI_EquipmentSetsHookEvents()
    hooksecurefunc("UnitPopup_ShowMenu", CleanUI_UnitPopup_AppendEquipmentSets);
end

function CleanUI_UnitPopup_AppendEquipmentSets(dropdownMenu, which, unit, name, userData)
    if (unit ~= "player" or UIDROPDOWNMENU_MENU_LEVEL > 1) then
        return;
    end

    UnitPopup_AddDropDownButton(UIDropDownMenu_CreateInfo(), UnitPopupButtons["SUBSECTION_SEPARATOR"], "SUBSECTION_SEPARATOR", UIDROPDOWNMENU_MENU_LEVEL);

    if (GetNumEquipmentSets() > 0) then
        local eq_header = UIDropDownMenu_CreateInfo();
        eq_header.text = "EquipmentSets";
        eq_header.isNotRadio = true;
        eq_header.notCheckable = 1;
        eq_header.isTitle = true;
        UIDropDownMenu_AddButton(eq_header);

        CleanUI_DetectEqippedSet();

        for ii=1, GetNumEquipmentSets() do
            local name = GetEquipmentSetInfo(ii);

            local info = UIDropDownMenu_CreateInfo();
            info.text = name;
            info.func = function(frame) CleanUI_SelectEquipmentSet(name) end;

            if (CleanUIData.EQUIPPED_SETNAME == name) then
                info.checked = true;
            end

            UIDropDownMenu_AddButton(info);
        end
    end
end

function CleanUI_UnitPopup_EquipmentSets_OnClick(self)
    if (string.find(self.value, "EQUIPMENTSETS_") == 1) then
        local name = UnitPopupButtons[self.value].text;
        CleanUI_SelectEquipmentSet(name);
    end
end

function CleanUI_DetectEqippedSet()
    local array = {};

    for ii=1, GetNumEquipmentSets() do
        local name = GetEquipmentSetInfo(ii);

        array = GetEquipmentSetLocations(name, array);

        local checksum = 0;
        local location, ltest;

        for index=1, 19 do
            location = array[index];

            -- check if location is an id
            if (location and tonumber(""..location) ~= nil) then
                --it's a number

                local player, bank, bags, voidStorage, slot, bag = EquipmentManager_UnpackLocation(location);

                if (player and not (bank or bags or bag)) then
                --DEFAULT_CHAT_FRAME:AddMessage("equipped", 1.0, 1.0, 1.0, 1, 10);
                else
                    if (slot and slot > 1) then
                        checksum = checksum - 1;
                    end
                end
            end;
        end

        if (checksum == 0) then
            CleanUIData.EQUIPPED_SETNAME = name;
            return;
        end
    end

    CleanUIData.EQUIPPED_SETNAME = nil;
end

function CleanUI_SelectEquipmentSet(name)
    UseEquipmentSet(name);
    PlaySound("igInventoryOepn");
    DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r equipment set "..name.." loaded.", 1.0, 1.0, 1.0, 1, 10);
end
