function CleanUI_InitItemUpgradeFrame()
    CleanUI_ItemUpgradeFrameHookEvents();
    CleanUI_RegisterItemUpgradeFrameEvents();
end

function CleanUI_RegisterItemUpgradeFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_ItemUpgradeFrameOnEvent);
end

function CleanUI_ItemUpgradeFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_ItemUpgradeUI" ) then
            CleanUI_CleanItemUpgradeFrame();
        end
    end
end

function CleanUI_ItemUpgradeFrameHookEvents()
--hooksecurefunc("", );
end

function CleanUI_CleanItemUpgradeFrame()
    CleanUI_RemoveTextures(ItemUpgradeFrame);
    CleanUI_SetBackdrop(ItemUpgradeFrame);

    CleanUI_RemoveTextures(ItemUpgradeFrame.ButtonFrame);
    CleanUI_RemoveTextures(ItemUpgradeFrameMoneyFrame);

    CleanUI_ChangeCloseButton(ItemUpgradeFrame);

    CleanUI_CreateHeaderFrame(ItemUpgradeFrame, "CUI_ItemUpgradeFrameHeaderBorderframe", 250, ItemUpgradeFrameTitleText);

    CleanUI_ChangeButton(ItemUpgradeFrameUpgradeButton);
end

