function CleanUI_InitMacroFrame()
    CleanUI_RegisterMacroFrameEvents();
end

function CleanUI_RegisterMacroFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_MacroFrameOnEvent);
end

function CleanUI_MacroFrameHookEvents()
--hooksecurefunc("", );
end

function CleanUI_MacroFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_MacroUI" ) then
            CleanUI_MacroFrameHookEvents();
            CleanUI_CleanMacroFrame();
        end
    end
end

function CleanUI_CleanMacroFrame()
    CleanUI_RemoveTextures(MacroFrame);
    CleanUI_SetBackdrop(MacroFrame);

    MacroFramePortrait:Hide();

    CleanUI_RemoveTextures(MacroFrameInset);

    CleanUI_ChangeCloseButton(MacroFrame);

    CleanUI_CreateHeaderFrame(MacroFrame, "CUI_MacroFrameHeaderBorderframe", 250, nil, CREATE_MACROS);

    CleanUI_ChangeFilterButton(MacroFrameTab1, true, -5, 0, -5, 0);
    CleanUI_ChangeFilterButton(MacroFrameTab2, true, -5, 0, -5, 0);

    CleanUI_RemoveTextures(MacroButtonScrollFrame);
    CleanUI_RemoveTextures(MacroFrameScrollFrame);

    MacroFrameTextBackground:Hide();

    CleanUI_ChangeButton(MacroEditButton);
    CleanUI_ChangeButton(MacroSaveButton);
    CleanUI_ChangeButton(MacroCancelButton);
    CleanUI_ChangeButton(MacroDeleteButton);
    CleanUI_ChangeButton(MacroNewButton);
    CleanUI_ChangeButtonRed(MacroExitButton);

    -- Popup
    CleanUI_RemoveTextures(MacroPopupFrame);
    CleanUI_SetBackdrop(MacroPopupFrame);

    CleanUI_ChangeButton(MacroPopupOkayButton);
    CleanUI_ChangeButtonRed(MacroPopupCancelButton);

    CleanUI_RemoveTextures(MacroPopupScrollFrame);

    MacroPopupCancelButton:SetPoint("BOTTOMRIGHT", -5, 8);
    CleanUI_ChangeEditBox(MacroPopupEditBox);

    for i=1, 20 do
        CleanUI_RemoveTextures(_G["MacroPopupButton"..i]);
        _G["MacroPopupButton"..i.."Icon"]:SetTexCoord(0.1, 0.9, 0.1, 0.9);
    end
end
