-- saved variables
CleanUIPetJournal = {};

local SAFARIHELM_ID = 92738;
local KAMPFHAUSTIERBANDAGE_ID = 86143;

local MAX_ACTIVE_PETS = 3;

-- saved data
CleanUIBattlePetGroups = {};

local petStats = {};

local selectedIndex = nil;

StaticPopupDialogs["CUI_BATTLEPET_GROUPS_ADD_TITLE_POPUP"] = {
    text = NAME,
    button1 = SAVE,
    button2 = CANCEL,
    OnShow = function (self, data)
        self.editBox:SetText(data or "nil")
    end,
    OnAccept = function (self, data, data2)
        CleanUI_AddPetBattleGroupWithName(self.editBox:GetText())
    end,
    hasEditBox = true,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
}

StaticPopupDialogs["CUI_BATTLEPET_GROUPS_RENAME_TITLE_POPUP"] = {
    text = BATTLE_PET_RENAME,
    button1 = SAVE,
    button2 = CANCEL,
    OnShow = function (self, data)
        self.editBox:SetText(data or "nil")
    end,
    OnAccept = function (self, data, data2)
        CleanUI_RenamePetBattleGroupWithName(self.editBox:GetText())
    end,
    hasEditBox = true,
    timeout = 0,
    whileDead = true,
    hideOnEscape = true,
}

function CleanUI_InitPetJournal()
    CleanUI_RegisterPetJournalEvents();
end

function CleanUI_RegisterPetJournalEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:RegisterEvent("UNIT_PORTRAIT_UPDATE");
    frame:RegisterEvent("PET_JOURNAL_LIST_UPDATE");
    frame:RegisterEvent("PET_JOURNAL_PET_DELETED");
    frame:RegisterEvent("PET_JOURNAL_PETS_HEALED");
    frame:RegisterEvent("BATTLE_PET_CURSOR_CLEAR");
    frame:RegisterEvent("COMPANION_UPDATE");
    frame:RegisterEvent("PET_BATTLE_LEVEL_CHANGED");
    frame:RegisterEvent("PET_BATTLE_QUEUE_STATUS");

    frame:RegisterEvent("BAG_UPDATE");

    frame:HookScript("OnEvent", CleanUI_PetJournalOnEvent);
end

function CleanUI_PetJournalHookEvents()
    hooksecurefunc("PetJournal_UpdatePetList", CleanUI_PetJournal_UpdatePetList);

    hooksecurefunc(CollectionsJournal, "Show", CleanUI_PetJournal_OnShow);
    hooksecurefunc(CollectionsJournal, "Hide", CleanUI_PetJournal_OnHide);

    PetJournalListScrollFrame:HookScript("OnVerticalScroll", CleanUI_PetJournal_UpdatePetList)
    PetJournalListScrollFrame:HookScript("OnMouseWheel", CleanUI_PetJournal_UpdatePetList)
end

function CleanUI_PetJournalOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_Collections" ) then
            CleanUI_PetJournalHookEvents();
            CleanUI_CleanPetJournal();
            CleanUI_InitPetBattleInfo();
            CleanUI_InitPetBattleGroups();
        end
    end
    if (event == "BAG_UPDATE") then
        CleanUI_PetJournal_BagUpdate();
    end

    CleanUI_BattlePetGroups_OnUpdate();
end

function CleanUI_CleanPetJournal()    
    CleanUI_RemoveTextures(CollectionsJournal);
    CleanUI_SetBackdrop(CollectionsJournal);

    CleanUI_RemoveTextures(PetJournal);
    CleanUI_RemoveTextures(MountJournal);

    PetJournalTutorialButton:Hide();
    CollectionsJournalPortrait:Hide();

    CleanUI_ChangeCloseButton(CollectionsJournal);
    CleanUI_CreateHeaderFrame(CollectionsJournal, "CUI_CollectionsJournalHeaderBorderframe", 250, CollectionsJournalTitleText);

    local tabButton;
    for i=1, 10 do
        tabButton = _G["CollectionsJournalTab"..i];
        if (not tabButton) then
            break;
        end

        CleanUI_ChangeTab(tabButton);
    end

    -- PetJournal
    PetJournalListScrollFrameScrollBarBG:Hide();
    PetJournalListScrollFrameScrollBarTop:Hide();
    PetJournalListScrollFrameScrollBarBottom:Hide();
    PetJournalListScrollFrameScrollBarMiddle:Hide();

    CleanUI_RemoveTextures(PetJournal.PetCount);
    CleanUI_RemoveTextures(PetJournal.LeftInset);
    CleanUI_RemoveTextures(PetJournal.RightInset);

    PetJournal.PetCount:SetPoint("TOPLEFT", 15, -20);

    CleanUI_ChangeEditBox(PetJournalSearchBox);

    PetJournalFilterButtonTopLeft:Hide();
    PetJournalFilterButtonTopMiddle:Hide();
    PetJournalFilterButtonTopRight:Hide();
    PetJournalFilterButtonMiddleLeft:Hide();
    PetJournalFilterButtonMiddleMiddle:Hide();
    PetJournalFilterButtonMiddleRight:Hide();
    PetJournalFilterButtonBottomLeft:Hide();
    PetJournalFilterButtonBottomMiddle:Hide();
    PetJournalFilterButtonBottomRight:Hide();

    CleanUI_ChangeButton(PetJournalSummonButton);
    CleanUI_ChangeButton(PetJournalFindBattle);

    PetJournalHealPetButton:SetPoint("CENTER", PetJournal, "TOPRIGHT", -28, -42);
    PetJournalHealPetButton.spellname:Hide();

    PetJournalHealPetButtonBorder:Hide();
    PetJournalHealPetButtonIconTexture:SetTexCoord(0.05, 0.95, 0.05, 0.95);
    local texture = PetJournalHealPetButton:CreateTexture("PetJournalHealPetButtonCUI_Border", "ARTWORK");
    texture:SetPoint("TOPLEFT", PetJournalHealPetButton, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", PetJournalHealPetButton, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");

    CleanUI_RemoveTextures(PetJournalPetCard);
    CleanUI_RemoveTextures(PetJournalPetCardInset);

    local parent, border;
    for i=1, MAX_ACTIVE_PETS do
        parent = _G["PetJournalLoadoutPet"..i];
        border = _G["PetJournalLoadoutPet"..i.."QualityBorder"];
        border:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
        border:SetPoint("TOPLEFT", parent.icon, "TOPLEFT", -12, 12);
        border:SetPoint("BOTTOMRIGHT", parent.icon, "BOTTOMRIGHT", 12, -14);
    end

    PetJournalPetCard.PetInfo.qualityBorder:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    PetJournalPetCard.PetInfo.qualityBorder:SetPoint("TOPLEFT", PetJournalPetCard.PetInfo.icon, "TOPLEFT", -12, 12);
    PetJournalPetCard.PetInfo.qualityBorder:SetPoint("BOTTOMRIGHT", PetJournalPetCard.PetInfo.icon, "BOTTOMRIGHT", 12, -14);

    -- button for 'Kampfhaustierbandage'
    local button = CreateFrame("Button", "CUI_KampfhaustierbandageButton", PetJournal, "PetJournalActionButtonTemplate");
    CUI_KampfhaustierbandageButton:GetNormalTexture():SetTexCoord(0.05, 0.95, 0.05, 0.95);
    CUI_KampfhaustierbandageButton:GetNormalTexture():SetTexture("Interface\\Icons\\INV_Misc_Bandage_05");
    button:SetPoint("RIGHT", PetJournalHealPetButton, "LEFT", -4, 0);
    texture = button:CreateTexture("CUI_KampfhaustierbandageButtonBorderTexture", "ARTWORK");
    texture:SetPoint("TOPLEFT", button, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");

    button:RegisterForClicks("AnyUp");
    button:SetAttribute("unit", "player");
    button:SetAttribute("type", "macro");
    button:SetAttribute("macrotext", "/use item:"..KAMPFHAUSTIERBANDAGE_ID);

    button:HookScript("OnEnter", CleanUI_PetJournal_ShowKampfhaustierbandageTooltip);
    button:HookScript("OnLeave", CleanUI_PetJournal_HideTooltip);

    -- button for 'Safarihelm'
    button = CreateFrame("Button", "CUI_SafarihelmButton", PetJournal, "PetJournalActionButtonTemplate");
    CUI_SafarihelmButton:GetNormalTexture():SetTexCoord(0.05, 0.95, 0.05, 0.95);
    CUI_SafarihelmButton:GetNormalTexture():SetTexture("Interface\\Icons\\INV_HELM_CLOTH_PETSAFARI_A_01");
    button:SetPoint("RIGHT", PetJournalHealPetButton, "LEFT", -41, 0);
    texture = button:CreateTexture("CUI_SafarihelmButtonBorderTexture", "ARTWORK");
    texture:SetPoint("TOPLEFT", button, "TOPLEFT", -14, 14);
    texture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 14, -14);
    texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
    texture:SetVertexColor(0.3, 0.3, 0.3);
    texture:SetDrawLayer("OVERLAY");

    button:RegisterForClicks("AnyUp");
    button:SetAttribute("unit", "player");
    button:SetAttribute("type", "macro");
    button:SetAttribute("macrotext", "/use item:"..SAFARIHELM_ID);

    button:HookScript("OnEnter", CleanUI_PetJournal_ShowSafarihelmTooltip);
    button:HookScript("OnLeave", CleanUI_PetJournal_HideTooltip);

    -- statistics
    local ref = nil;
    local index;
    for i=1, 5 do
        index = i;
        if (index == 5) then
            index = 0;
        end

        local texture = CreateFrame("StatusBar", "PetJournalStatistics"..index, PetJournal, "CleanUIActionButtonDeBuffBarTemplate");

        if (not ref) then
            texture:SetPoint("TOPLEFT", PetJournal,  15, -50);
        else
            texture:SetPoint("LEFT", ref, "RIGHT", 0, 0);
        end

        ref = texture;

        texture:SetSize(20, 10);
        texture:SetMinMaxValues(0, 100);
        texture:SetValue(100);
        texture:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);

        if (index > 0) then
            texture:SetStatusBarColor(ITEM_QUALITY_COLORS[index-1].r, ITEM_QUALITY_COLORS[index-1].g, ITEM_QUALITY_COLORS[index-1].b);
        else
            texture:SetStatusBarColor(1, 1, 0);
        end

        texture:HookScript("OnLeave", CleanUI_PetJournal_HideTooltip);
    end

    _G["PetJournalStatistics0"]:HookScript("OnEnter", function() CleanUI_PetJournal_ShowStatisticsTooltip(0); end);
    _G["PetJournalStatistics1"]:HookScript("OnEnter", function() CleanUI_PetJournal_ShowStatisticsTooltip(1); end);
    _G["PetJournalStatistics2"]:HookScript("OnEnter", function() CleanUI_PetJournal_ShowStatisticsTooltip(2); end);
    _G["PetJournalStatistics3"]:HookScript("OnEnter", function() CleanUI_PetJournal_ShowStatisticsTooltip(3); end);
    _G["PetJournalStatistics4"]:HookScript("OnEnter", function() CleanUI_PetJournal_ShowStatisticsTooltip(4); end);

    -- check button visibility
    CleanUI_PetJournal_BagUpdate();

    -- MountJournal
    MountJournalFilterButtonTopLeft:Hide();
    MountJournalFilterButtonTopMiddle:Hide();
    MountJournalFilterButtonTopRight:Hide();
    MountJournalFilterButtonMiddleLeft:Hide();
    MountJournalFilterButtonMiddleMiddle:Hide();
    MountJournalFilterButtonMiddleRight:Hide();
    MountJournalFilterButtonBottomLeft:Hide();
    MountJournalFilterButtonBottomMiddle:Hide();
    MountJournalFilterButtonBottomRight:Hide();
    
    MountJournalListScrollFrameScrollBarBG:Hide();
    MountJournalListScrollFrameScrollBarTop:Hide();
    MountJournalListScrollFrameScrollBarBottom:Hide();
    MountJournalListScrollFrameScrollBarMiddle:Hide();

    CleanUI_RemoveTextures(MountJournal.MountCount);
    CleanUI_RemoveTextures(MountJournal.MountDisplay);
    CleanUI_RemoveTextures(MountJournal.MountDisplay.ShadowOverlay);
    CleanUI_RemoveTextures(MountJournal.LeftInset);
    CleanUI_RemoveTextures(MountJournal.RightInset);

    MountJournal.MountCount:SetPoint("TOPLEFT", 15, -20);

    CleanUI_ChangeEditBox(MountJournalSearchBox);
    CleanUI_ChangeButton(MountJournalMountButton);
    
    -- toy box
    CleanUI_RemoveTextures(ToyBox.iconsFrame);
    CleanUI_ChangeEditBox(ToyBox.searchBox);
    
    ToyBoxFilterButtonTopLeft:Hide();
    ToyBoxFilterButtonTopMiddle:Hide();
    ToyBoxFilterButtonTopRight:Hide();
    ToyBoxFilterButtonMiddleLeft:Hide();
    ToyBoxFilterButtonMiddleMiddle:Hide();
    ToyBoxFilterButtonMiddleRight:Hide();
    ToyBoxFilterButtonBottomLeft:Hide();
    ToyBoxFilterButtonBottomMiddle:Hide();
    ToyBoxFilterButtonBottomRight:Hide();
    
    -- heirlooms
    CleanUI_RemoveTextures(HeirloomsJournal.iconsFrame);
    CleanUI_ChangeEditBox(HeirloomsJournalSearchBox);
    CleanUI_ChangeDropDown(HeirloomsJournalClassDropDown);
    
    HeirloomsJournalFilterButtonTopLeft:Hide();
    HeirloomsJournalFilterButtonTopMiddle:Hide();
    HeirloomsJournalFilterButtonTopRight:Hide();
    HeirloomsJournalFilterButtonMiddleLeft:Hide();
    HeirloomsJournalFilterButtonMiddleMiddle:Hide();
    HeirloomsJournalFilterButtonMiddleRight:Hide();
    HeirloomsJournalFilterButtonBottomLeft:Hide();
    HeirloomsJournalFilterButtonBottomMiddle:Hide();
    HeirloomsJournalFilterButtonBottomRight:Hide();
end

function CleanUI_PetJournal_ShowStatisticsTooltip(id)
    GameTooltip:SetOwner(_G["PetJournalStatistics"..id], "ANCHOR_RIGHT");

    local color = {r=1.0, g=1.0, b=0.0};
    local text = "";

    if (id == 1) then
        text = BATTLE_PET_BREED_QUALITY1..":";
    elseif (id == 2) then
        text = BATTLE_PET_BREED_QUALITY2..":";
    elseif (id == 3) then
        text = BATTLE_PET_BREED_QUALITY3..":";
    elseif (id == 4) then
        text = BATTLE_PET_BREED_QUALITY4..":";
    end

    if (id > 0) then
        color = ITEM_QUALITY_COLORS[id-1];
    end

    GameTooltip:SetText(text.." "..(petStats[id] or 0), color.r, color.g, color.b);
    GameTooltip:Show();
end

function CleanUI_PetJournal_ShowKampfhaustierbandageTooltip()
    GameTooltip:SetOwner(CUI_KampfhaustierbandageButton, "ANCHOR_RIGHT");
    local itemName, itemLink = GetItemInfo(KAMPFHAUSTIERBANDAGE_ID);
    GameTooltip:SetHyperlink(itemLink);
    GameTooltip:Show();
end

function CleanUI_PetJournal_ShowSafarihelmTooltip()
    GameTooltip:SetOwner(CUI_SafarihelmButton, "ANCHOR_RIGHT");
    local itemName, itemLink = GetItemInfo(SAFARIHELM_ID);
    GameTooltip:SetHyperlink(itemLink);
    GameTooltip:Show();
end

function CleanUI_PetJournal_HideTooltip()
    GameTooltip:FadeOut();
end

function CleanUI_PetJournal_BagUpdate()
    local itemCount;

    if (CUI_KampfhaustierbandageButton) then
        itemCount = GetItemCount(KAMPFHAUSTIERBANDAGE_ID);
        if (itemCount > 0) then
            CUI_KampfhaustierbandageButton:Show();
            CUI_KampfhaustierbandageButtonCount:SetText(""..itemCount);
        else
            CUI_KampfhaustierbandageButton:Hide();
        end
    end

    if (CUI_SafarihelmButton) then
        itemCount = GetItemCount(SAFARIHELM_ID);
        if (itemCount > 0) then
            CUI_SafarihelmButton:Show();
        else
            CUI_SafarihelmButton:Hide();
        end
    end
end

function CleanUI_PetJournal_UpdatePetList()
    CleanUI_PetJournal_UpdatePetCount();
    CleanUI_PetJournal_UpdateCompanionListButtons();

    local scrollFrame = PetJournal.listScroll;
    local offset = HybridScrollFrame_GetOffset(scrollFrame);
    local petButtons = scrollFrame.buttons;
    local pet, index;

    local numPets, numOwned = C_PetJournal.GetNumPets();

    for i = 1,#petButtons do
        pet = petButtons[i];
        pet.name:SetWidth(125);

        if (not pet.cuihealth) then
            pet.cuihealth = CreateFrame("Frame", pet:GetName().."CUI_HEATH", pet, "CleanUIPetInfoHealthTemplate");
            --pet.cuihealth:SetFrameStrata("MEDIUM");
            pet.cuihealth:SetPoint("TOPRIGHT", pet, "TOPRIGHT", -10, -5);
            pet.cuihealth:SetScale(0.75);
        end

        if (not pet.cuiexp) then
            pet.cuiexp = CreateFrame("StatusBar", pet:GetName().."CUI_EXP", pet, "CleanUIPetExpStatusBarTemplate");
            --pet.cuiexp:SetFrameStrata("MEDIUM");
            pet.cuiexp:SetPoint("BOTTOMLEFT", pet, "BOTTOMLEFT", 7, 4);
            pet.cuiexp:SetPoint("BOTTOMRIGHT", pet, "BOTTOMRIGHT", -7, 4);
        end

        index = offset + i;
        if index <= numPets then
            local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(index);
            if isOwned then
                local health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);
                local speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID = C_PetJournal.GetPetInfoByPetID(petID);

                pet.cuihealth:Show();
                pet.cuihealth.healthValue:SetFormattedText(PET_BATTLE_CURRENT_HEALTH_FORMAT, health, maxHealth);
                pet.cuihealth.healthBar:SetMinMaxValues(0, maxHealth);
                pet.cuihealth.healthBar:SetValue(health);

                if(level < 25) then
                    pet.cuiexp:Show();
                    pet.cuiexp:SetMinMaxValues(0, maxXp);
                    pet.cuiexp:SetValue(xp);
                else
                    pet.cuiexp:Hide();
                end
            else
                pet.cuihealth:Hide();
                pet.cuiexp:Hide();
            end
        end
    end
end

function CleanUI_PetJournal_OnShow(self)
    -- load settings
    C_PetJournal.SetPetSortParameter(CleanUIPetJournal.sortParameter or LE_SORT_BY_NAME);
end

function CleanUI_PetJournal_OnHide(self)
    -- save settings
    CleanUIPetJournal.sortParameter = C_PetJournal.GetPetSortParameter();
end

function CleanUI_PetJournal_UpdatePetCount()
    local pets = {};

    petStats = {};

    local numUnique = 0;

    local numPets, numOwned = C_PetJournal.GetNumPets();

    local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle;
    local health, maxHealth, attack, speed, rarity;
    for i = 1, numPets do
        petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(i);
        if (isOwned) then
            health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);

            petStats[rarity] = (petStats[rarity] or 0) + 1;

            if (speciesID and not pets[speciesID]) then
                numUnique = numUnique + 1;
                pets[speciesID] = speciesID;
            end
        else
            petStats[0] = (petStats[0] or 0) + 1;
        end
    end

    local width = 0;
    for i=0, 4 do
        width = 240 / numPets * (petStats[i] or 0);
        if (width < 1) then
            width = 0.1;
        end

        _G["PetJournalStatistics"..i]:SetWidth(width);
    end

    PetJournal.PetCount.Count:SetText(numOwned.." ("..numUnique..")");
end

function CleanUI_PetJournal_UpdateCompanionListButtons()
    local scrollFrame = PetJournal.listScroll;
    local offset = HybridScrollFrame_GetOffset(scrollFrame);
    local petButtons = scrollFrame.buttons;
    local pet, index;

    local numPets, numOwned = C_PetJournal.GetNumPets();

    local summonedPetID = C_PetJournal.GetSummonedPetGUID();

    local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle;
    local health, maxHealth, attack, speed, rarity;
    local border;
    for i = 1,#petButtons do
        pet = petButtons[i];
        CleanUI_PetJournal_CreateButtonBorder(pet);
        index = offset + i;
        if index <= numPets then
            petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = C_PetJournal.GetPetInfoByIndex(index);
            border = _G[pet:GetName().."CUI_Border"];

            if (isOwned) then
                health, maxHealth, attack, speed, rarity = C_PetJournal.GetPetStats(petID);
                pet.name:SetTextColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
                border:SetVertexColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
            else
                pet.name:SetTextColor(0.9, 0.9, 0.0);
                border:SetVertexColor(0.5, 0.5, 0.5);
            end
        end
    end
end

function CleanUI_PetJournal_CreateButtonBorder(button)
    button.iconBorder:Hide();
    button.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95);

    local texture = _G[button:GetName().."CUI_Border"];

    if (not texture) then
        texture = button:CreateTexture(button:GetName().."CUI_Border", "ARTWORK");
        texture:SetPoint("TOPLEFT", button.iconBorder, "TOPLEFT", -14, 14);
        texture:SetPoint("BOTTOMRIGHT", button.iconBorder, "BOTTOMRIGHT", 14, -14);
        texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\bag\\item_border");
        texture:Show();
    end
end

function CleanUI_InitPetBattleInfo()
    local button = CreateFrame("Button", "CUIPetBattleInfoButton", PetJournal, "UIPanelButtonTemplate");
    button:SetWidth(30);
    button:SetHeight(22);
    button:SetPoint("TOPRIGHT", PetJournal, "TOPRIGHT", -100, -225);
    button:SetText("?");
    button:SetScript("OnClick", CleanUI_TogglePetBattleInfo);
    button:SetFrameLevel(button:GetFrameLevel() + 1);
    CleanUI_ChangeButton(button);

    local infoFrame = CreateFrame("Frame", "CleanUIBattlePetInfoFrame", PetJournal, "CleanUIBattlePetInfoFrameTemplate");
    CleanUI_SetBackdrop(infoFrame);
    infoFrame:SetSize(380, 400);
    infoFrame:ClearAllPoints();
    infoFrame:SetPoint("BOTTOMLEFT", PetJournal, "BOTTOMRIGHT", -2, 0);
    CleanUI_CreateHeaderFrame(infoFrame, "CUI_BattlePetInfoFrameHeaderBorderframe", 150, nil, "Matrix");
    CleanUI_ChangeCloseButton(infoFrame);

    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameAddButton);
    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameSaveButton);
    CleanUI_ChangeButtonRed(CleanUIBattlePetGroupsFrameDeleteButton);

    infoFrame.background = infoFrame:CreateTexture("ARTWORK");
    infoFrame.background:SetSize(364, 364);
    infoFrame.background:SetPoint("CENTER", infoFrame, "CENTER", 0, -10);
    infoFrame.background:SetTexture("Interface\\AddOns\\CleanUI\\skins\\petbattle\\petbattle_matrix");
    
    infoFrame.vs = infoFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlightLarge2");
    infoFrame.vs:SetText("vs.");
    infoFrame.vs:SetPoint("TOPLEFT", infoFrame, "TOPLEFT", 12, -35);
    
    infoFrame.attacking = infoFrame:CreateFontString(nil, "ARTWORK", "GameFontHighlight");
    infoFrame.attacking:SetText("attacking");
    infoFrame.attacking:SetPoint("TOP", infoFrame, "TOP", 0, -20);
    
    for i=1, C_PetJournal.GetNumPetTypes() do
        local typeIcon1 = infoFrame:CreateTexture("ARTWORK");
        typeIcon1:SetSize(26, 26);
        typeIcon1:SetPoint("TOPLEFT", infoFrame, "TOPLEFT", 14, -37 - i * 32);
        typeIcon1:SetTexCoord(0.79687500, 0.49218750, 0.50390625, 0.65625000);
        typeIcon1:SetTexture("Interface\\PetBattles\\PetIcon-"..PET_TYPE_SUFFIX[i]);
        
        local typeIcon2 = infoFrame:CreateTexture("ARTWORK");
        typeIcon2:SetSize(26, 26);
        typeIcon2:SetPoint("TOPLEFT", infoFrame, "TOPLEFT", 16 + i * 32, -36);
        typeIcon2:SetTexCoord(0.79687500, 0.49218750, 0.50390625, 0.65625000);
        typeIcon2:SetTexture("Interface\\PetBattles\\PetIcon-"..PET_TYPE_SUFFIX[i]);
    end
    
    CleanUI_TogglePetBattleInfoWinner(1, 2, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(1, 8, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(2, 6, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(2, 4, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(3, 9, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(3, 2, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(4, 1, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(4, 9, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(5, 4, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(5, 1, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(6, 3, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(6, 10, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(7, 10, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(7, 5, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(8, 5, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(8, 3, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(9, 7, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(9, 6, READY_CHECK_NOT_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(10, 8, READY_CHECK_READY_TEXTURE);
    CleanUI_TogglePetBattleInfoWinner(10, 7, READY_CHECK_NOT_READY_TEXTURE);
end

function CleanUI_TogglePetBattleInfoWinner(x, y, texture)
    local icon = CleanUIBattlePetInfoFrame:CreateTexture("ARTWORK");
    icon:SetSize(26, 26);
    icon:SetPoint("TOPLEFT", CleanUIBattlePetInfoFrame, "TOPLEFT", 16 + x * 32, -37 - y * 32);
    icon:SetTexture(texture);
end

function CleanUI_TogglePetBattleInfo()
    if (CleanUIBattlePetInfoFrame:IsVisible()) then
        CleanUIBattlePetInfoFrame:Hide();
    else
        CleanUIBattlePetGroupsFrame:Hide();
        CleanUIBattlePetInfoFrame:Show();
    end
end

function CleanUI_InitPetBattleGroups()
    local button = CreateFrame("Button", "CUIPetBattleGroupsButton", PetJournal, "UIPanelButtonTemplate");
    button:SetWidth(100);
    button:SetHeight(22);
    button:SetPoint("TOPRIGHT", PetJournal, "TOPRIGHT", -6, -225);
    button:SetText(GROUPS);
    button:SetScript("OnClick", CleanUI_TogglePetBattleGroups);
    button:SetFrameLevel(button:GetFrameLevel() + 1);
    CleanUI_ChangeButton(button);

    local groupsFrame = CreateFrame("Frame", "CleanUIBattlePetGroupsFrame", PetJournal, "CleanUIBattlePetGroupsFrameTemplate");
    CleanUI_SetBackdrop(groupsFrame);
    groupsFrame:SetSize(265, 606);
    groupsFrame:ClearAllPoints();
    groupsFrame:SetPoint("BOTTOMLEFT", PetJournal, "BOTTOMRIGHT", -2, 0);
    CleanUI_CreateHeaderFrame(groupsFrame, "CUI_BattlePetGroupsFrameHeaderBorderframe", 150, nil, GROUPS);
    CleanUI_ChangeCloseButton(groupsFrame);

    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameAddButton);
    CleanUI_ChangeButton(CleanUIBattlePetGroupsFrameSaveButton);
    CleanUI_ChangeButtonRed(CleanUIBattlePetGroupsFrameDeleteButton);

    -- create gui
    HybridScrollFrame_OnLoad(CleanUIBattlePetGroupsFrame.scrollFrame);
    CleanUIBattlePetGroupsFrame.scrollFrame.update = CleanUI_BattlePetGroups_OnUpdate;
    HybridScrollFrame_CreateButtons(CleanUIBattlePetGroupsFrame.scrollFrame, "CleanUIBattlePetGroupsEntryTemplate");
end

function CleanUI_TogglePetBattleGroups()
    if (CleanUIBattlePetGroupsFrame:IsVisible()) then
        CleanUIBattlePetGroupsFrame:Hide();
    else
        CleanUIBattlePetInfoFrame:Hide();
        CleanUIBattlePetGroupsFrame:Show();
        CleanUI_BattlePetGroups_OnUpdate();
    end
end

function CleanUI_BattlePetGroups_OnUpdate()
    if (not CleanUIBattlePetGroupsFrame) then
        return;
    end

    --update ui stats
    local groupsActive = 1;
    for p=1, MAX_ACTIVE_PETS do
        _, _, _, _, locked = C_PetJournal.GetPetLoadOutInfo(p);
        if (locked) then
            groupsActive = nil;
        end
    end

    if (groupsActive) then
        CUIPetBattleGroupsButton:Enable();
    else
        CUIPetBattleGroupsButton:Disable();
    end

    -- update group frame
    CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:Hide();

    local buttons = CleanUIBattlePetGroupsFrame.scrollFrame.buttons;

    local numEntries = #CleanUIBattlePetGroups;
    local numButtons = #buttons;

    local scrollOffset = HybridScrollFrame_GetOffset(CleanUIBattlePetGroupsFrame.scrollFrame);
    local buttonHeight = buttons[1]:GetHeight();
    local displayedHeight = 0;

    local entry;
    local data;

    for i=1, numButtons do
        local entryIndex = i + scrollOffset;
        entry = buttons[i];

        if ( entryIndex <= numEntries ) then
            data = CleanUIBattlePetGroups[entryIndex];

            entry:Show();
            entry.index = entryIndex;

            -- button data
            entry:SetText(data.name);

            -- pet data
            local id, health, maxHealth, power, speed, rarity;
            local speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID, sourceText, description, isWild, canBattle, tradable, unique, obtainable;
            local pet;
            for p=1, MAX_ACTIVE_PETS do
                id = data.pet[p].petGUID;
                
                if (id) then
                    health, maxHealth, power, speed, rarity = C_PetJournal.GetPetStats(id);

                    speciesID, customName, level, xp, maxXp, displayID, isFavorite, name, icon, petType, creatureID, sourceText, description, isWild, canBattle, tradable, unique, obtainable = C_PetJournal.GetPetInfoByPetID(id) ;
    
                    pet = _G[entry:GetName().."Pet"..p];
    
                    rarity = rarity or 1;
    
                    pet.PetInfo.icon:SetTexture(icon);
                    pet.PetInfo.qualityBorder:SetVertexColor(ITEM_QUALITY_COLORS[rarity-1].r, ITEM_QUALITY_COLORS[rarity-1].g, ITEM_QUALITY_COLORS[rarity-1].b);
                    pet.PetInfo.level:SetText(level);
    
                    if (isFavorite) then
                        pet.PetInfo.favorite:Show();
                    else
                        pet.PetInfo.favorite:Hide();
                    end
    
                    pet.PetInfo.typeIcon:SetTexture(GetPetTypeTexture(petType));
                    pet.PetInfo.isDead:SetShown((health or 0) <= 0);
    
                    -- tooltip info
                    pet.speciesName = name;
                    pet.sourceText = sourceText;
                    pet.tradable = tradable;
                    pet.unique = unique;
    
                    if ( description and description ~= "" ) then
                        pet.description = format([["%s"]], description);
                    else
                        pet.description = nil;
                    end
                end
            end

            -- this isn't a header, hide the header textures
            entry:SetNormalTexture("");
            entry:SetHighlightTexture("");

            if (entryIndex == selectedIndex) then
                -- reposition highlight frames
                CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:SetParent(entry);
                CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:SetAllPoints(entry.name);
                CleanUIBattlePetGroupsFrame.scrollFrame.highlightFrame:Show();
            end
        else
            entry:Hide();
        end

        displayedHeight = displayedHeight + buttonHeight;
    end

    HybridScrollFrame_Update(CleanUIBattlePetGroupsFrame.scrollFrame, numEntries * buttonHeight, displayedHeight);
end

function CleanUI_BattlePetGroupsPet_OnEnter(self)
    GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 0, 0);
    GameTooltip:SetText(self.speciesName, 1, 1, 1);
    GameTooltip:AddLine(self.sourceText, 1, 1, 1, true);
    if ( not self.tradable ) then
        GameTooltip:AddLine(BATTLE_PET_NOT_TRADABLE, 1, 0.1, 0.1, true);
    end
    if ( self.unique ) then
        GameTooltip:AddLine(ITEM_UNIQUE, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, true);
    end
    if ( self.description and self.description ~= "" ) then
        GameTooltip:AddLine(" ");
        GameTooltip:AddLine(self.description, nil, nil, nil, true);
    end
    GameTooltip:Show();
end

function CleanUI_BattlePetGroupsPet_OnLeave(self)
    GameTooltip:FadeOut();
end

function CleanUI_BattlePetGroupsEntry_OnClick(self, button, down)
    PlaySound("ACTIONBARBUTTONDOWN");
    selectedIndex = self.index;
    CleanUI_BattlePetGroups_OnUpdate();

    local data = CleanUIBattlePetGroups[selectedIndex];

    if (button == "LeftButton") then
    elseif (button == "RightButton") then
        local dialog = StaticPopup_Show("CUI_BATTLEPET_GROUPS_RENAME_TITLE_POPUP");
        local editbox = _G[dialog:GetName().."EditBox"];
        editbox:SetText(data.name or "");
    end
end

function CleanUI_BattlePetGroupsEntry_OnDoubleClick(self)
    if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
        return;
    end

    local data = CleanUIBattlePetGroups[selectedIndex];

    for i=1, MAX_ACTIVE_PETS do
        C_PetJournal.SetPetLoadOutInfo(i, data.pet[i].petGUID);
        C_PetJournal.SetAbility(i, 1, data.pet[i].ability1);
        C_PetJournal.SetAbility(i, 2, data.pet[i].ability2);
        C_PetJournal.SetAbility(i, 3, data.pet[i].ability3);
    end

    PetJournal_UpdateAll();
end

function CleanUI_BattlePetGroups_ResetSelection()
    selectedIndex = nil;
end

function CleanUI_AddPetBattleGroup()
    local dialog = StaticPopup_Show("CUI_BATTLEPET_GROUPS_ADD_TITLE_POPUP");
    local editbox = _G[dialog:GetName().."EditBox"];
    editbox:SetText("");
end

function CleanUI_AddPetBattleGroupWithName(name)
    local data = {};
    data.pet = {};

    data.name = name;

    CleanUI_UpdateBattlePetGroupData(data);

    tinsert(CleanUIBattlePetGroups, data);

    CleanUI_BattlePetGroups_OnUpdate();
end

function CleanUI_RenamePetBattleGroupWithName(name)
    if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
        return;
    end

    local data = CleanUIBattlePetGroups[selectedIndex];

    data.name = name;

    CleanUI_BattlePetGroups_OnUpdate();
end

function CleanUI_SavePetBattleGroup()
    if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
        return;
    end

    local data = CleanUIBattlePetGroups[selectedIndex];

    CleanUI_UpdateBattlePetGroupData(data);

    CleanUI_BattlePetGroups_OnUpdate();
end

function CleanUI_DeletePetBattleGroup()
    if (not selectedIndex or selectedIndex > #CleanUIBattlePetGroups) then
        return;
    end

    tremove(CleanUIBattlePetGroups, selectedIndex);

    CleanUI_BattlePetGroups_ResetSelection();
    CleanUI_BattlePetGroups_OnUpdate();
end


function CleanUI_UpdateBattlePetGroupData(data)
    local petGUID, ability1, ability2, ability3, locked;
    local petdata;
    for i=1, 3 do
        petGUID, ability1, ability2, ability3, locked = C_PetJournal.GetPetLoadOutInfo(i);
        data.pet[i] = {petGUID = petGUID, ability1 = ability1, ability2 = ability2, ability3 = ability3};
    end
end
