function CleanUI_InitPvpFrame()
    CleanUI_PvpFrameHookEvents();
    CleanUI_RegisterPvpFrameEvents();
end

function CleanUI_RegisterPvpFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_PvpFrameOnEvent);
end

function CleanUI_PvpFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_PVPUI" ) then
            CleanUI_CleanPvpUiFrame();
        end
    end
end

function CleanUI_PvpFrameHookEvents()
--hooksecurefunc("MerchantFrame_UpdateMerchantInfo", CleanUI_MerchantFrame_UpdateMerchantInfo);
end

function CleanUI_CleanPvpUiFrame()
    CleanUI_RemoveTextures(PVPUIFrame);
    CleanUI_SetBackdrop(PVPUIFrame);

    -- HonorFrame
    CleanUI_ChangeButton(HonorFrameSoloQueueButton);
    CleanUI_ChangeButton(HonorFrameGroupQueueButton);

    CleanUI_RemoveTextures(HonorFrame.BonusFrame);
    CleanUI_RemoveTextures(HonorFrame.Inset);
    CleanUI_RemoveTextures(HonorFrame.RoleInset);
    HonorFrameSpecificFrameScrollBarBG:Hide();
    HonorFrameSpecificFrameScrollBarTop:Hide();
    HonorFrameSpecificFrameScrollBarBottom:Hide();
    HonorFrameSpecificFrameScrollBarMiddle:Hide();

    HonorFrameSoloQueueButton:SetPoint("BOTTOMLEFT", 90, 4);
    HonorFrameGroupQueueButton:SetPoint("BOTTOMRIGHT", 1, 4);

    -- ConquestFrame
    CleanUI_RemoveTextures(ConquestFrame);
    CleanUI_RemoveTextures(ConquestFrame.Inset);

    CleanUI_ChangeButton(ConquestJoinButton);
    ConquestJoinButton:ClearAllPoints();
    ConquestJoinButton:SetPoint("BOTTOMLEFT", 90, 8);

    -- WarGamesFrame
    CleanUI_RemoveTextures(WarGamesFrame);
    CleanUI_RemoveTextures(WarGamesFrame.RightInset);
    CleanUI_RemoveTextures(WarGamesFrame.scrollFrame);

    WarGamesFrameScrollFrameScrollBarBG:Hide();
    WarGamesFrameScrollFrameScrollBarTop:Hide();
    WarGamesFrameScrollFrameScrollBarBottom:Hide();
    WarGamesFrameScrollFrameScrollBarMiddle:Hide();

    WarGamesFrameInfoScrollFrame.scrollBarBackground:Hide();
    WarGamesFrameInfoScrollFrame.scrollBarArtTop:Hide();
    WarGamesFrameInfoScrollFrame.scrollBarArtBottom:Hide();

    WarGamesFrame.HorizontalBar:Hide();

    CleanUI_ChangeButton(WarGameStartButton);
    WarGameStartButton:SetPoint("BOTTOMLEFT", 90, 3);
end
