function CleanUI_InitReforgingFrame()
    CleanUI_ReforgingFrameHookEvents();
    CleanUI_RegisterReforgingFrameEvents();
end

function CleanUI_RegisterReforgingFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_ReforgingFrameOnEvent);
end

function CleanUI_ReforgingFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_ReforgingUI" ) then
            CleanUI_CleanReforgingFrame();
        end
    end
end

function CleanUI_ReforgingFrameHookEvents()
--hooksecurefunc("", );
end

function CleanUI_CleanReforgingFrame()
    CleanUI_RemoveTextures(ReforgingFrame);
    CleanUI_SetBackdrop(ReforgingFrame);

    CleanUI_RemoveTextures(ReforgingFrame.ButtonFrame);

    CleanUI_ChangeCloseButton(ReforgingFrame);

    CleanUI_CreateHeaderFrame(ReforgingFrame, "CUI_ReforgingFrameHeaderBorderframe", 250, ReforgingFrameTitleText);

    ReforgingFrameMoneyFrame:SetPoint("BOTTOMRIGHT", ReforgingFrame.ButtonFrame, "BOTTOMLEFT", 175, 7);

    ReforgingFrameRestoreButton:SetSize(120, 22);
    ReforgingFrameRestoreButton:ClearAllPoints();
    ReforgingFrameRestoreButton:SetPoint("BOTTOMRIGHT", ReforgingFrame.ButtonFrame, "BOTTOMRIGHT", -104, 5);

    ReforgingFrameReforgeButton:SetSize(100, 22);
    ReforgingFrameReforgeButton:ClearAllPoints();
    ReforgingFrameReforgeButton:SetPoint("BOTTOMRIGHT", ReforgingFrame.ButtonFrame, "BOTTOMRIGHT", -2, 5);

    CleanUI_ChangeButton(ReforgingFrameRestoreButton);
    CleanUI_ChangeButton(ReforgingFrameReforgeButton);
end

