-- 	DEFAULT_CHAT_FRAME:AddMessage("CleanUI_FactionChange", 1.0, 1.0, 1.0, 1, 10);

local max_time = 120; -- seconds

local starttime = 0;

function CleanUI_InitReputation()
    local frame = CreateFrame("Frame");
    frame:HookScript("OnUpdate", CleanUI_ReputationOnUpdate);

    frame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");

    frame:HookScript("OnEvent", CleanUI_ReputationOnEvent);

    CleanUI_ReputationHookEvents();
end

function CleanUI_ReputationOnEvent(self, event, ...)
    -- UPDATE_FACTION
    if (event == "CHAT_MSG_COMBAT_FACTION_CHANGE") then
        local message = ...;
        CleanUI_FactionChange(message);
    end
end

function CleanUI_ReputationHookEvents()
    hooksecurefunc("SetWatchedFactionIndex", CleanUI_SetWatchedFactionIndex);
end

function CleanUI_SetWatchedFactionIndex(faction)
    if (faction > 0) then
        starttime = GetTime();
    else
        starttime = 0;
    end
end

local UPDATE_WAIT = 0.5;
local _WaitTimeSinceLast = 0;
function CleanUI_ReputationOnUpdate(self, elapsed)
    if (_WaitTimeSinceLast <= 0) then
        CleanUI_ReputationUpdate();
        _WaitTimeSinceLast = UPDATE_WAIT;
    else
        _WaitTimeSinceLast = _WaitTimeSinceLast - elapsed;
    end
end

function CleanUI_FactionChange(message)
    local faction = CleanUI_CheckReputationMessage(message);

    if (faction ~= nil) then
        SetWatchedFactionIndex(faction);
    --starttime = GetTime();
    else
        CleanUI_HideWatchedFaction();
    end
end

function CleanUI_ReputationUpdate()

    local time = GetTime();

    if (time - starttime > max_time) then
        CleanUI_HideWatchedFaction();
    end
end

function CleanUI_HideWatchedFaction()
    SetWatchedFactionIndex(0);
--starttime = 0;
end

function CleanUI_CheckReputationMessage(message)

    -- use guild name
    if (string.find(message,GUILD)) then
        local guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
        message = "'"..guildName.."'";
    end

    local index = 1;

    repeat
        local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(index);

        if (name ~= nil and string.find(message,name) ~= nil) then
            barValue = barValue - barMin;
            barMax = barMax - barMin;

            local friendID, friendRep, friendMaxRep, friendName, friendText, friendTexture, friendTextLevel, friendThreshold, nextFriendThreshold = GetFriendshipReputation(factionID);

            if (friendID ~= nil and friendThresh ~= nil) then
                factionStandingtext = friendTextLevel;
                barValue = friendRep - friendThresh;
                barMax = min( friendMaxRep - friendThresh, 8400);
                barMin = 0;
            end

            local pct = 100 * barValue / barMax;

            local info = HIGHLIGHT_FONT_COLOR_CODE.." "..barValue.." / "..barMax.." ("..format("%d", pct).." %)"..FONT_COLOR_CODE_CLOSE;
            DEFAULT_CHAT_FRAME:AddMessage(name..": "..info, 1.0, 1.0, 1.0, 1, 10);

            return index;
        end

        index = index + 1;

    until (index > 200);

    return nil;
end
