local oldname = nil;

function CleanUI_InitTalents()
    CleanUI_TalentsHookEvents();
end

function CleanUI_TalentsHookEvents()
    hooksecurefunc("UnitPopup_ShowMenu", CleanUI_UnitPopup_AppendTalents);
end

function CleanUI_UnitPopup_AppendTalents(dropdownMenu, which, unit, name, userData)

    if (unit ~= "player" or UIDROPDOWNMENU_MENU_LEVEL > 1) then
        return;
    end

    UnitPopup_AddDropDownButton(UIDropDownMenu_CreateInfo(), UnitPopupButtons["SUBSECTION_SEPARATOR"], "SUBSECTION_SEPARATOR", UIDROPDOWNMENU_MENU_LEVEL);

    if (GetNumSpecGroups() > 1) then
        local eq_header = UIDropDownMenu_CreateInfo();
        eq_header.text = TALENTS;
        eq_header.isNotRadio = true;
        eq_header.notCheckable = 1;
        eq_header.isTitle = true;
        UIDropDownMenu_AddButton(eq_header);

        local activeTalentGroup = GetActiveSpecGroup();

        for ii=1, GetNumSpecGroups() do
            local name = CleanUI_DetectSpecGroupName(ii);

            local info = UIDropDownMenu_CreateInfo();
            info.text = name;
            info.func = function(frame) CleanUI_SelectActiveSpecGroup(ii) end;

            if (ii == activeTalentGroup) then
                info.checked = true;
            end

            UIDropDownMenu_AddButton(info);
        end
    end
end

function CleanUI_DetectSpecGroupName(index)
    local specGroup = GetSpecialization(false, false, index);
    if (specGroup) then
        local id, name, description, icon, background, role = GetSpecializationInfo(specGroup);
        return name;
    end

    return nil;
end

function CleanUI_SelectActiveSpecGroup(index)
    SetActiveSpecGroup(index);
end
