function CleanUI_InitTooltips()
    CleanUI_TooltipsHookEvents();
    CleanUI_RegisterTooltipsEvents();
end

function CleanUI_RegisterTooltipsEvents()
--local frame = CreateFrame("Frame");

--frame:RegisterEvent("");

--frame:HookScript("OnEvent", CleanUI_TooltipsOnEvent);
end

function CleanUI_TooltipsOnEvent(self, event, ...)
end

function CleanUI_TooltipsHookEvents()
    hooksecurefunc("GameTooltip_SetDefaultAnchor", CleanUI_GameTooltip_SetDefaultAnchor);
    hooksecurefunc("GameTooltip_OnUpdate", CleanUI_GameTooltip_OnUpdate);
end

function CleanUI_GameTooltip_OnUpdate(self, elapsed)
end

function CleanUI_GameTooltip_SetDefaultAnchor(tooltip, parent, ...)
    -- hide in combat
    if (CleanUIData.TOOLTIPS_HIDEINCOMBAT and InCombatLockdown()) then
        tooltip:Hide();
        return;
    end

    if (not parent) then
        parent = GetMouseFocus();
    end

    if (not parent or (parent.GetName and parent:GetName() == "WorldFrame")) then
        parent = UIParent;
    end

    if (CleanUIData.TOOLTIPS_POSITION == 1) then
        -- default
        tooltip:SetOwner(parent, "ANCHOR_NONE");
        tooltip:ClearAllPoints();
        tooltip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 200);
    elseif (CleanUIData.TOOLTIPS_POSITION == 2) then
        -- mouse position
        if parent.unit then
            tooltip:SetOwner(parent, "ANCHOR_PRESERVE");
        else
            tooltip:SetOwner(parent, "ANCHOR_CURSOR");
        end
    elseif (CleanUIData.TOOLTIPS_POSITION == 3) then
        -- top
        tooltip:SetOwner(parent, "ANCHOR_NONE");
        tooltip:ClearAllPoints();
        tooltip:SetPoint("TOP", UIParent, "TOP", 0, -65);
    elseif (CleanUIData.TOOLTIPS_POSITION == 4) then
        -- bottom right
        tooltip:SetOwner(parent, "ANCHOR_NONE");
        tooltip:ClearAllPoints();
        tooltip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -100, 10);
    end
end
