function CleanUI_InitTransmogrifyFrame()
    CleanUI_TransmogrifyFrameHookEvents();
    CleanUI_RegisterTransmogrifyFrameEvents();
end

function CleanUI_RegisterTransmogrifyFrameEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_TransmogrifyFrameOnEvent);
end

function CleanUI_TransmogrifyFrameOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "Blizzard_ItemAlterationUI" ) then
            CleanUI_CleanTransmogrifyFrame();
        end
    end
end

function CleanUI_TransmogrifyFrameHookEvents()
--hooksecurefunc("", );
end

function CleanUI_CleanTransmogrifyFrame()
    CleanUI_RemoveTextures(TransmogrifyFrame);
    CleanUI_RemoveTextures(TransmogrifyArtFrame);
    CleanUI_RemoveTextures(TransmogrifyModelFrame);
    CleanUI_SetBackdrop(TransmogrifyFrame);

    CleanUI_RemoveTextures(TransmogrifyFrameButtonFrame);

    CleanUI_ChangeCloseButton(TransmogrifyArtFrame);

    CleanUI_CreateHeaderFrame(TransmogrifyArtFrame, "CUI_TransmogrifyArtFrameHeaderBorderframe", 250, TransmogrifyArtFrameTitleText);

    CleanUI_ChangeButton(TransmogrifyApplyButton);
end

