function CleanUI_InitSelfieCam()
    CleanUI_RegisterSelfieCamEvents();
    CleanUI_SelfieCamHookEvents();
    
    CleanUISelfieCamActions:SetParent(OverrideActionBar);
    CleanUISelfieCamActions:ClearAllPoints();
    CleanUISelfieCamActions:SetPoint("TOPRIGHT", OverrideActionBar, "TOPRIGHT", -157, -20);
    
    CleanUISelfieCamActions:SetSize(162, 73);
    
    CleanUI_UpdateSelfieCam();
end

function CleanUI_RegisterSelfieCamEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("UPDATE_EXTRA_ACTIONBAR");

    frame:HookScript("OnEvent", CleanUI_SelfieCamOnEvent);
end

function CleanUI_SelfieCamOnEvent(self, event, ...)
    if (event == "UPDATE_EXTRA_ACTIONBAR") then
        CleanUI_StartDelay(0.1, CleanUI_UpdateSelfieCam);
        CleanUI_StartDelay(2.0, CleanUI_UpdateSelfieCam);
    end
end

function CleanUI_SelfieCamHookEvents()
    --hooksecurefunc("xx", CleanUI_xx);
end

function CleanUI_UpdateSelfieCam()    
    local type, id, subType = GetActionInfo(157);
    
    local usable = IsUsableAction(157);
    local texture = GetActionTexture(157);
    
    if (usable and id == 181842 and OverrideActionBarButton1:IsVisible() and texture == "Interface\\Icons\\inv_misc_enggizmos_27") then
        CleanUISelfieCamActions:Show();
    else
        CleanUISelfieCamActions:Hide();
    end
end

function CleanUI_SelfieCam_ShowTooltip(self, text)
    GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
    GameTooltip:SetText(text);
    GameTooltip:Show();
end

function CleanUI_SelfieCam_HideTooltip()
    GameTooltip:FadeOut();
end